using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Bustools1553
{
   public class API
   {
      private const String dllPath = @"busapi32.DLL";

      [DllImport(dllPath, EntryPoint = "BusTools_SetInterrupts")]
      public static extern Int32 SetInterrupts
      (
         UInt32 cardnum,
         Int32 wInterrup,
         Int32 wFlag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_DumpMemory")]
      public static extern Int32 DumpMemory
      (
         UInt32 cardnum,
         UInt32 region_mask,
         String file_name,
         String heading
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_MessageReadData")]
      public static extern Int32 BC_MessageReadData
      (
         UInt32 cardnum,
         UInt32 messno,
         [In, Out] UInt16[] buffer
      );
      [DllImport(dllPath, EntryPoint = "BusTools_API_Close")]
      public static extern Int32 API_Close
      (
         UInt32 cardnum
      );
      [DllImport(dllPath, EntryPoint = "BusTools_API_InitExtended")]
      public static extern Int32 API_InitExtended
      (
         UInt32 cardnum,
         UInt32 base_address,
         UInt32 ioaddr,
         ref UInt32 flag,
         UInt32 platform,
         UInt32 boardType,
         UInt32 carrier,
         UInt32 slot,
         UInt32 mapping
      );
      [DllImport(dllPath, EntryPoint = "BusTools_GetAddr")]
      public static extern Int32 GetAddr
      (
         UInt32 cardnum,
         UInt32 memtype,
         ref UInt32 start,
         ref UInt32 end1
      );
      [DllImport(dllPath, EntryPoint = "BusTools_GetRevision")]
      public static extern Int32 GetRevision
      (
         UInt32 cardnum,
         ref UInt32 ucode_rev,
         ref UInt32 api_rev
      );
      [DllImport(dllPath, EntryPoint = "BusTools_InterruptDone")]
      public static extern Int32 InterruptDone
      (
         UInt32 cardnum
      );
      [DllImport(dllPath, EntryPoint = "BusTools_InterruptRegister")]
      public static extern Int32 InterruptRegister
      (
         UInt32 cardnum,
         Int32 inttype,
         Int32 hwnd,
         Int32 message_id,
         Int32 flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_MemoryAlloc")]
      public static extern Int32 MemoryAlloc
      (
         UInt32 cardnum,
         UInt32 segnum,
         UInt32 bcount,
         ref UInt32 addr
      );
      [DllImport(dllPath, EntryPoint = "BusTools_MemoryRead")]
      public static extern Int32 MemoryRead
      (
         UInt32 cardnum,
         UInt32 addr,
         UInt32 bcount,
         [In, Out] Byte[] buffer
      );
      [DllImport(dllPath, EntryPoint = "BusTools_MemoryWrite")]
      public static extern Int32 MemoryWrite
      (
         UInt32 cardnum,
         UInt32 addr,
         UInt32 bcount,
         [In, Out] Byte[] buffer
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RecordDone")]
      public static extern Int32 RecordDone
      (
         UInt32 cardnum
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RecordGetFlag")]
      public static extern Int32 RecordGetFlag
      (
         UInt32 cardnum,
         ref Int32 flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RecordRegister")]
      public static extern Int32 RecordRegister
      (
         UInt32 cardnum,
         Int32 hwnd,
         Int32 flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RegisterFunction")]
      public static extern Int32 RegisterFunction
      (
         UInt32 cardnum,
         // this parameter is not a a pointer to a managed INT_FIFO class, but a pointer to one that
         // the API created in unmanaged code with CreateIntFifo.
         IntPtr intFIFO,
         UInt32 wFlag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_SetBroadcast")]
      public static extern Int32 SetBroadcast
      (
         UInt32 cardnum,
         UInt32 bcast
      );
      [DllImport(dllPath, EntryPoint = "BusTools_SetInternalBus")]
      public static extern Int32 SetInternalBus
      (
         UInt32 cardnum,
         UInt32 busflag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_SetNRLRTimeout")]
      public static extern Int32 SetNRLRTimeout
      (
         UInt32 cardnum,
         UInt32 wTimeout1,
         UInt32 wTimeout2
      );
      [DllImport(dllPath, EntryPoint = "BusTools_SetOptions")]
      public static extern Int32 SetOptions
      (
         UInt32 cardnum,
         UInt32 intFlag,
         UInt32 resettimer,
         UInt32 trig_on_sync,
         UInt32 enable_rt
      );
      [DllImport(dllPath, EntryPoint = "BusTools_SetSa31")]
      public static extern Int32 SetSa31
      (
         UInt32 cardnum,
         UInt32 sa31
      );
      [DllImport(dllPath, EntryPoint = "BusTools_SetVoltage")]
      public static extern Int32 SetVoltage
      (
         UInt32 cardnum,
         UInt32 voltage,
         UInt32 voltflag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_AperiodicRun")]
      public static extern Int32 BC_AperiodicRun
      (
         UInt32 cardnum,
         UInt32 messageid,
         UInt32 Hipriority,
         UInt32 WaitFlag,
         UInt32 WaitTime
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_AperiodicTest")]
      public static extern Int32 BC_AperiodicTest
      (
         UInt32 cardnum,
         UInt32 Hipriority
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_Init")]
      public static extern Int32 BC_Init
      (
         UInt32 cardnum,
         UInt32 bc_options,
         UInt32 enable,
         UInt32 wRetry,
         UInt32 wTimeout1,
         UInt32 wTimeout2,
         UInt32 frame_period,
         UInt32 num_buffers
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_IsRunning")]
      public static extern Int32 BC_IsRunning
      (
         UInt32 cardnum,
         ref UInt32 flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_MessageAlloc")]
      public static extern Int32 BC_MessageAlloc
      (
         UInt32 cardnum,
         UInt32 count
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_MessageGetaddr")]
      public static extern Int32 BC_MessageGetaddr
      (
         UInt32 cardnum,
         UInt32 messageid,
         ref UInt32 addr
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_MessageGetid")]
      public static extern Int32 BC_MessageGetid
      (
         UInt32 cardnum,
         UInt32 addr,
         ref UInt32 messageid
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_MessageNoop")]
      public static extern Int32 BC_MessageNoop
      (
         UInt32 cardnum,
         UInt32 messageid,
         UInt32 NoopFlag,
         UInt32 WaitFlag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_MessageUpdate")]
      public static extern Int32 BC_MessageUpdate
      (
         UInt32 cardnum,
         UInt32 mblock_id,
         [In] UInt16[] buffer
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_ReadLastMessage")]
      public static extern Int32 BC_ReadLastMessage
      (
         Int32 cardnum,
         Int32 rt_addr,
         Int32 subaddress,
         Int32 tr,
         [In,Out] DataTypes.API_BC_MBUF pBC_mbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_ReadLastMessageBlock")]
      public static extern Int32 BC_ReadLastMessageBlock
      (
         Int32 cardnum,
         Int32 rt_addr_mask,
         Int32 subaddr_mask,
         Int32 tr,
         ref UInt32 mcount,
         [In,Out] DataTypes.API_BC_MBUF_STRUCT[] pBC_mbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_ReadNextMessage")]
      public static extern Int32 BC_ReadNextMessage
      (
         Int32 cardnum,
         UInt32 timeout,
         Int32 rt_addr,
         Int32 subaddress,
         Int32 tr,
         [In,Out] DataTypes.API_BC_MBUF pBC_mbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_RetryInit")]
      public static extern Int32 BC_RetryInit
      (
         UInt32 cardnum,
         UInt16[] bc_retry
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_Start")]
      public static extern Int32 BC_Start
      (
         UInt32 cardnum,
         UInt32 message_num
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_StartStop")]
      public static extern Int32 BC_StartStop
      (
         UInt32 cardnum,
         UInt32 flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_Trigger")]
      public static extern Int32 BC_Trigger
      (
         UInt32 cardnum,
         Int32 trigger_mode
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BIT_InternalBit")]
      public static extern Int32 BIT_InternalBit
      (
         UInt32 cardnum,
         Int32 NumMessages
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BIT_TwoBoardWrap")]
      public static extern Int32 BIT_TwoBoardWrap
      (
         UInt32 FirstCard,
         UInt32 SecondCard,
         Int32 TestPrimary,
         Int32 TestSecondary,
         Int32 NumMessages,
         Int32 rt_addr,
         Int32 RT_subaddr
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BIT_CableWrap")]
      public static extern Int32 BIT_CableWrap
      (
         UInt32 cardnum,
         Int32 NumMessages
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BM_Init")]
      public static extern Int32 BM_Init
      (
         UInt32 cardnum,
         UInt32 bm_ctrl1,
         UInt32 bm_ctrl2
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BM_MessageAlloc")]
      public static extern Int32 BM_MessageAlloc
      (
         UInt32 cardnum,
         UInt32 mbuf_count,
         ref UInt32 mbuf_actual,
         UInt32 enable
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BM_MessageGetid")]
      public static extern Int32 BM_MessageGetid
      (
         UInt32 cardnum,
         UInt32 addr,
         ref UInt32 messageid
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BM_StartStop")]
      public static extern Int32 BM_StartStop
      (
         UInt32 cardnum,
         UInt32 flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BM_ReadLastMessage")]
      public static extern Int32 BM_ReadLastMessage
      (
         Int32 cardnum,
         Int32 rt_addr,
         Int32 subaddress,
         Int32 tr,
         [In,Out] DataTypes.API_BM_MBUF pBM_mbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BM_ReadLastMessageBlock")]
      public static extern Int32 BM_ReadLastMessageBlock
      (
         Int32 cardnum,
         Int32 rt_addr_mask,
         Int32 subaddr_mask,
         Int32 tr,
         ref UInt32 mcount,
         [In,Out] DataTypes.API_BM_MBUF_STRUCT[] pBM_mbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BM_ReadNextMessage")]
      public static extern Int32 BM_ReadNextMessage
      (
         Int32 cardnum,
         UInt32 timeout,
         Int32 rt_addr,
         Int32 subaddress,
         Int32 tr,
         [In,Out] DataTypes.API_BM_MBUF pBM_mbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_EI_Getaddr")]
      public static extern Int32 EI_Getaddr
      (
         UInt32 cardnum,
         UInt32 errorid,
         ref UInt32 addr
      );
      [DllImport(dllPath, EntryPoint = "BusTools_EI_Getid")]
      public static extern Int32 EI_Getid
      (
         UInt32 cardnum,
         UInt32 addr,
         ref UInt32 errorid
      );
      [DllImport(dllPath, EntryPoint = "BusTools_ErrorCountClear")]
      public static extern Int32 ErrorCountClear
      (
         UInt32 cardnum
      );
      [DllImport(dllPath, EntryPoint = "BusTools_ErrorCountGet")]
      public static extern Int32 ErrorCountGet
      (
         UInt32 cardnum,
         ref UInt32 count,
         [In, Out] UInt32[] buffer
      );
      [DllImport(dllPath, EntryPoint = "BusTools_Playback")]
      public static extern Int32 Playback
      (
         UInt32 cardnum,
         [In,Out] DataTypes.API_PLAYBACK playbackdata
      );
      [DllImport(dllPath, EntryPoint = "BusTools_Playback_Stop")]
      public static extern Int32 Playback_Stop
      (
         UInt32 cardnum
      );
      [DllImport(dllPath, EntryPoint = "BusTools_ReadVMEConfig")]
      public static extern Int32 ReadVMEConfig
      (
         Int32 cardnum,
         [In, Out] UInt16[] vdata
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_AbufRead")]
      public static extern Int32 RT_AbufRead
      (
         UInt32 cardnum,
         UInt32 rtaddress,
         [In,Out] DataTypes.API_RT_ABUF abuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_AbufWrite")]
      public static extern Int32 RT_AbufWrite
      (
         UInt32 cardnum,
         UInt32 rtaddress,
         [In,Out] DataTypes.API_RT_ABUF abuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_CbufbroadRead")]
      public static extern Int32 RT_CbufbroadRead
      (
         UInt32 cardnum,
         UInt32 subaddr,
         UInt32 tr,
         [In, Out] DataTypes.API_RT_CBUFBROAD apicbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_CbufbroadWrite")]
      public static extern Int32 RT_CbufbroadWrite
      (
         UInt32 cardnum,
         UInt32 subaddr,
         UInt32 tr,
         [In, Out] DataTypes.API_RT_CBUFBROAD apicbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_CbufRead")]
      public static extern Int32 RT_CbufRead
      (
         UInt32 cardnum,
         UInt32 rtaddr,
         UInt32 subaddr,
         UInt32 tr,
         ref UInt32 mbuf_count,
         [In,Out] DataTypes.API_RT_CBUF apicbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_CbufWrite")]
      public static extern Int32 RT_CbufWrite
      (
         UInt32 cardnum,
         UInt32 rtaddr,
         UInt32 subaddr,
         UInt32 tr,
         Int32 mbuf_count,
         [In,Out] DataTypes.API_RT_CBUF apicbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_Init")]
      public static extern Int32 RT_Init
      (
         UInt32 cardnum,
         UInt32 testflag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_MessageGetid")]
      public static extern Int32 RT_MessageGetid
      (
         UInt32 cardnum,
         UInt32 addr,
         ref UInt32 rtaddr,
         ref UInt32 subaddr,
         ref UInt32 tr,
         ref UInt32 mbuf_id
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_MessageWriteStatusWord")]
      public static extern Int32 RT_MessageWriteStatusWord
      (
         UInt32 cardnum,
         UInt32 rtaddr,
         UInt32 subaddr,
         UInt32 tr,
         UInt32 mbuf_id,
         UInt16 wStatusWord,
         UInt32 wFlag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_MonitorEnable")]
      public static extern Int32 RT_MonitorEnable
      (
         UInt32 cardnum,
         UInt32 rtaddress,
         UInt32 mode
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_ReadLastMessage")]
      public static extern Int32 RT_ReadLastMessage
      (
         Int32 cardnum,
         Int32 rt_addr,
         Int32 subaddress,
         Int32 tr,
         [In,Out] DataTypes.API_RT_MBUF_READ pRT_mbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_ReadLastMessageBlock")]
      public static extern Int32 RT_ReadLastMessageBlock
      (
         Int32 cardnum,
         Int32 rt_addr_mask,
         Int32 subaddr_mask,
         Int32 tr,
         ref UInt32 mcount,
         [In,Out] DataTypes.API_RT_MBUF_READ_STRUCT[] pRT_mbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_ReadNextMessage")]
      public static extern Int32 RT_ReadNextMessage
      (
         Int32 cardnum,
         UInt32 timeout,
         Int32 rt_addr,
         Int32 subaddress,
         Int32 tr,
         [In,Out] DataTypes.API_RT_MBUF_READ pRT_mbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_StartStop")]
      public static extern Int32 RT_StartStop
      (
         UInt32 cardnum,
         UInt32 flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_MessageRead")]
      public static extern Int32 BC_MessageRead
      (
         UInt32 cardnum,
         UInt32 messno,
         [In,Out] DataTypes.API_BC_MBUF bcMessage
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_MessageWrite")]
      public static extern Int32 BC_MessageWrite
      (
         UInt32 cardnum,
         UInt32 messno,
         [In, Out] DataTypes.API_BC_MBUF bcMessage
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BM_FilterRead")]
      public static extern Int32 BM_FilterRead
      (
         UInt32 cardnum,
         UInt32 rtaddr,
         UInt32 subaddr,
         UInt32 tr,
         [In,Out] DataTypes.API_BM_CBUF cbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BM_FilterWrite")]
      public static extern Int32 BM_FilterWrite
      (
         UInt32 cardnum,
         UInt32 rtaddr,
         UInt32 subaddr,
         UInt32 tr,
         [In,Out] DataTypes.API_BM_CBUF cbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BM_MessageRead")]
      public static extern Int32 BM_MessageRead
      (
         UInt32 cardnum,
         UInt32 mbuf_id,
         [In,Out] DataTypes.API_BM_MBUF mbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BM_MessageReadBlock")]
      public static extern Int32 BM_MessageReadBlock
      (
         UInt32 cardnum,
         [In,Out] DataTypes.API_BM_MBUF_STRUCT[] api_mbuf,
         UInt32 size,
         UInt32 curpos,
         ref UInt32 ret_count
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BM_TriggerRead")]
      public static extern Int32 BM_TriggerRead
      (
         UInt32 cardnum,
         [In,Out] DataTypes.API_BM_TBUF tbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BM_TriggerWrite")]
      public static extern Int32 BM_TriggerWrite
      (
         UInt32 cardnum,
         [In,Out] DataTypes.API_BM_TBUF tbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_InterMessageGap")]
      public static extern Int32 InterMessageGap
      (
         [In,Out] DataTypes.API_BM_MBUF first,
         [In,Out] DataTypes.API_BM_MBUF second
      );
      [DllImport(dllPath, EntryPoint = "BusTools_InterMessageGap2")]
      public static extern Int32 InterMessageGap2
      (
         UInt32 flag,
         [In,Out] DataTypes.API_BM_MBUF first,
         [In,Out] DataTypes.API_BM_MBUF second
      );
      [DllImport(dllPath, EntryPoint = "BusTools_IRIG_Calibration")]
      public static extern Int32 IRIG_Calibration
      (
         UInt32 cardnum,
         Int32 flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_IRIG_Config")]
      public static extern Int32 IRIG_Config
      (
         UInt32 cardnum,
         UInt32 intFlag,
         UInt32 outFlag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_IRIG_SetTime")]
      public static extern Int32 IRIG_SetTime
      (
         UInt32 cardnum,
         UInt64 timedate,
         UInt32 IRIGTime
      );
      [DllImport(dllPath, EntryPoint = "BusTools_IRIG_Valid")]
      public static extern Int32 IRIG_Valid
      (
         UInt32 cardnum
      );
      [DllImport(dllPath, EntryPoint = "BusTools_EI_EbufRead")]
      public static extern Int32 EI_EbufRead
      (
         UInt32 cardnum,
         UInt32 errorid,
         [In,Out] DataTypes.API_EIBUF ebuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_EI_EbufWrite")]
      public static extern Int32 EI_EbufWrite
      (
         UInt32 cardnum,
         UInt32 errorid,
         [In,Out] DataTypes.API_EIBUF ebuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_MessageRead")]
      public static extern Int32 RT_MessageRead
      (
         UInt32 cardnum,
         UInt32 rtaddr,
         UInt32 subaddr,
         UInt32 tr,
         UInt32 mbuf_id,
         [In,Out] DataTypes.API_RT_MBUF_READ mbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_MessageBufferNext")]
      public static extern Int32 RT_MessageBufferNext
      (
         UInt32 cardnum,
         UInt32 rtaddr,
         UInt32 subaddr,
         UInt32 tr,
         ref UInt32 mbuf_id
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_MessageWrite")]
      public static extern Int32 RT_MessageWrite
      (
         UInt32 cardnum,
         UInt32 rtaddr,
         UInt32 subaddr,
         UInt32 tr,
         UInt32 mbuf_id,
         [In,Out] DataTypes.API_RT_MBUF_WRITE mbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_MessageWriteDef")]
      public static extern Int32 RT_MessageWriteDef
      (
         UInt32 cardnum,
         UInt32 rtaddr,
         [In,Out] DataTypes.API_RT_MBUF_WRITE mbuf
      );
      [DllImport(dllPath, EntryPoint = "BusTools_StatusGetStringLV")]
      public static extern Int32 StatusGetStringLV
      (
         Int32 status,
         String string1
      );
      [DllImport(dllPath, EntryPoint = "BusTools_TimeGetString")]
      public static extern Int32 TimeGetString
      (
         ref DataTypes.BT1553_TIME curtime,
         StringBuilder string1
      );
      [DllImport(dllPath, EntryPoint = "BusTools_TimeTagInit")]
      public static extern Int32 TimeTagInit
      (
         UInt32 cardnum
      );
      [DllImport(dllPath, EntryPoint = "BusTools_TimeTagMode")]
      public static extern Int32 TimeTagMode
      (
         UInt32 cardnum,
         Int32 TTDisplay,
         Int32 TTInit,
         Int32 TTMode,
         String DLLanme,
         UInt32 TTPeriod,
         UInt32 lParm1,
         UInt32 lParm2
      );
      [DllImport(dllPath, EntryPoint = "BusTools_TimeTagRead")]
      public static extern Int32 TimeTagRead
      (
         UInt32 cardnum,
         ref DataTypes.BT1553_TIME timetag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_TimeTagWrite")]
      public static extern Int32 TimeTagWrite
      (
         UInt32 cardnum,
         ref DataTypes.BT1553_TIME timetag,
         Int32 flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_WriteVMEConfig")]
      public static extern Int32 WriteVMEConfig
      (
//         UInt32 cardnum,
//         Int32 offset,
//         Int32 vdata
         Int32 cardnum,
         UInt32 offset,
         UInt16 vdata
      );
      [DllImport(dllPath, EntryPoint = "BusTools_SetTestBus")]
      public static extern Int32 SetTestBus
      (
         UInt32 cardnum,
         UInt32 busflag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_DiscreteSetIO")]
      public static extern Int32 DiscreteSetIO
      (
         UInt32 cardnum,
         UInt32 disflag,
         UInt32 mask
      );
      [DllImport(dllPath, EntryPoint = "BusTools_DiscreteRead")]
      public static extern Int32 DiscreteRead
      (
         UInt32 cardnum,
         Int32 disSel,
         ref UInt32 disValue
      );
      [DllImport(dllPath, EntryPoint = "BusTools_DiscreteWrite")]
      public static extern Int32 DiscreteWrite
      (
         UInt32 cardnum,
         Int32 disSel,
         UInt32 disflag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_GetRTAddr")]
      public static extern Int32 RT_GetRTAddr
      (
         UInt32 cardnum,
         ref Int32 rtaddr
      );
      [DllImport(dllPath, EntryPoint = "BusTools_DiscreteGetIO")]
      public static extern Int32 DiscreteGetIO
      (
         UInt32 cardnum,
         ref UInt32 disDirValue
      );
      [DllImport(dllPath, EntryPoint = "BusTools_DiscreteTriggerOut")]
      public static extern Int32 DiscreteTriggerOut
      (
         UInt32 cardnum,
         Int32 disflag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_DiscreteTriggerIn")]
      public static extern Int32 DiscreteTriggerIn
      (
         UInt32 cardnum,
         Int32 trigflag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_DiffTriggerOut")]
      public static extern Int32 DiffTriggerOut
      (
         UInt32 cardnum,
         Int32 chflag,
         Int32 diffen
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_AutoIncrMessageData")]
      public static extern Int32 BC_AutoIncrMessageData
      (
         Int32 cardnum,
         Int32 messno,
         Int32 data_wrd,
         Int16 start,
         Int16 incr,
         Int32 rate1,
         UInt16 max,
         Int32 sflag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_AutoIncrMessageData")]
      public static extern Int32 RT_AutoIncrMessageData
      (
         Int32 cardnum,
         Int32 rtaddr,
         Int32 subaddr,
         Int32 data_wrd,
         UInt16 start,
         UInt16 incr,
         Int32 rate1,
         UInt16 max,
         Int32 sflag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BM_Checksum1760")]
      public static extern Int32 BM_Checksum1760
      (
         [In,Out] DataTypes.API_BM_MBUF mbuf,
         ref UInt16 chksum
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RT_Checksum1760")]
      public static extern Int32 RT_Checksum1760
      (
         [In,Out] DataTypes.API_RT_MBUF_WRITE mbuf,
         ref UInt16 chksum,
         Int32 vdcnt
      );
      [DllImport(dllPath, EntryPoint = "BusTools_Checksum1760")]
      public static extern Int32 Checksum1760
      (
         ref UInt16 mbuf,
         Int32 vdcnt
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BM_SetRT_RT_INT")]
      public static extern Int32 BM_SetRT_RT_INT
      (
         UInt32 cardnum,
         UInt32 iflag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_API_OpenChannel")]
      public static extern Int32 OpenChannel
      (
         out UInt32 chnd,
         UInt32 mode,
         Int32 devid,
         UInt32 channel
      );
      [DllImport(dllPath, EntryPoint = "BusTools_FindDevice")]
      public static extern Int32 FindDevice
      (
         Int32 device_type,
         Int32 instance
      );
      [DllImport(dllPath, EntryPoint = "BusTools_ListDevices")]
      public static extern Int32 ListDevices
      (
         [In,Out] DataTypes.DEVICE_LIST list
      );
      [DllImport(dllPath, EntryPoint = "BusTools_SetPolling")]
      public static extern Int32 SetPolling
      (
         UInt32 polling
      );
      [DllImport(dllPath, EntryPoint = "BusTools_GetFWRevision")]
      public static extern Int32 GetFWRevision
      (
         UInt32 cardnum,
         out Single wrev,
         out Single lrev,
         out Int32 build
      );
      [DllImport(dllPath, EntryPoint = "BusTools_GetPulse")]
      public static extern Int32 GetPulse
      (
         UInt32 cardnum,
         out UInt32 beat
      );
      [DllImport(dllPath, EntryPoint = "BusTools_GetChannelStatus")]
      public static extern Int32 GetChannelStatus
      (
         UInt32 cardnum,
         ref Int32 cstat
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_MessageReadDataBuffer")]
      public static extern Int32 BC_MessageReadDataBuffer
      (
         UInt32 cardnum,
         UInt32 mblock_id,
         UInt32 buffer_id,
         [In,Out] UInt16[] buffer
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_MessageUpdateBuffer")]
      public static extern Int32 BC_MessageUpdateBuffer
      (
         UInt32 cardnum,
         UInt32 mblock_id,
         UInt32 buffer_id,
         [In, Out] UInt16[] buffer
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_ControlWordUpdate")]
      public static extern Int32 BC_ControlWordUpdate
      (
         UInt32 cardnum,
         UInt32 messageid,
         UInt16 wControlWord,
         UInt32 WaitFlag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_ExtTriggerOut")]
      public static extern Int32 ExtTriggerOut
      (
         UInt32 cardnum,
         UInt16 pwidth
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_SetFrameRate")]
      public static extern Int32 BC_SetFrameRate
      (
         UInt32 cardnum,
         UInt32 frame
      );
      [DllImport(dllPath, EntryPoint = "BusTools_Playback_Check")]
      public static extern Int32 Playback_Check
      (
         String arg1,
         UInt32 arg2
      );
      [DllImport(dllPath, EntryPoint = "BusTools_GetDevInfo")]
      public static extern Int32 GetDevInfo
      (
         UInt32 cardnum,
         [In,Out] DataTypes.DEVICE_INFO Info
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RS485_TX_Enable")]
      public static extern Int32 RS485_TX_Enable
      (
         UInt32 cardnum,
         UInt16 enable,
         UInt16 mask
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RS485_Set_TX_Data")]
      public static extern Int32 RS485_Set_TX_Data
      (
         UInt32 cardnum,
         UInt16 rsdata,
         UInt16 mask
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RS485_ReadRegs")]
      public static extern Int32 RS485_ReadRegs
      (
         UInt32 cardnum,
         Int32 regval,
         out UInt32 rsdata
      );
      [DllImport(dllPath, EntryPoint = "BusTools_ExtTrigIntEnable")]
      public static extern Int32 ExtTrigIntEnable
      (
         UInt32 cardnum,
         UInt32 flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_GetBoardType")]
      public static extern Int32 GetBoardType
      (
         UInt32 cardnum
      );
      [DllImport(dllPath, EntryPoint = "BusTools_GetCSCRegs")]
      public static extern Int32 GetCSCRegs
      (
         UInt32 cardnum,
         UInt16 csc,
         UInt16 acr
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BoardIsUSBMon")]
      public static extern Int32 BoardIsUSBMon
      (
         UInt32 cardnum
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BoardIsV6")]
      public static extern Int32 BoardIsV6
      (
         UInt32 cardnum
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BoardHasIRIG")]
      public static extern Int32 BoardHasIRIG
      (
         UInt32 cardnum
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BoardIsMultiFunction")]
      public static extern Int32 BoardIsMultiFunction
      (
         UInt32 cardnum
      );
      [DllImport(dllPath, EntryPoint = "BusTools_GetChannelCount")]
      public static extern Int32 GetChannelCount
      (
         UInt32 cardnum
      );
      [DllImport(dllPath, EntryPoint = "BusTools_PCI_Reset")]
      public static extern Int32 PCI_Reset
      (
         Int32 cardnum,
         UInt32 reset_flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_DMA_setup")]
      public static extern Int32 DMA_setup
      (
         UInt32 cardnum,
         UInt32 dma_channel,
         UInt32 host_addr,
         UInt32 board_addr,
         UInt32 byte_count,
         UInt32 dma_flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_DMA_Start")]
      public static extern Int32 DMA_Start
      (
         UInt32 cardnum,
         UInt32 dma_channel
      );
      [DllImport(dllPath, EntryPoint = "BusTools_CreateIntFifo")]
      public static extern IntPtr CreateIntFifo
      (
         DataTypes.API_INT_FIFO_Callback callbackFunc
      );
      [DllImport(dllPath, EntryPoint = "BusTools_UpdateIntFifo")]
      public static extern Int32 UpdateIntFifo
      (
         // pointer to unmanaged IntFifo created by API
         IntPtr oldIntFifo,
         // a managed IntFifo created by .NET app
         DataTypes.API_INT_FIFO newIntFifo
      );
      [DllImport(dllPath, EntryPoint = "BusTools_UpdateTailPTR")]
      public static extern Int32 UpdateTailPTR
      (
         IntPtr intFifo,
         Int32 newTail
      );
      [DllImport(dllPath, EntryPoint = "BusTools_SetTermEnable")]
      public static extern Int32 SetTermEnable
      (
         UInt32 cardnum,
         UInt16 tEnable
      );
      [DllImport(dllPath, EntryPoint = "BusTools_GetTermEnable")]
      public static extern Int32 GetTermEnable
      (
         UInt32 cardnum,
         ref UInt32 tEnable
      );
      [DllImport(dllPath, EntryPoint = "BusTools_ReadBoardTemp")]
      public static extern Int32 ReadBoardTemp
      (
         Int32 cardnum,
         UInt32 location,
         ref Int32 temperature
      );
      [DllImport(dllPath, EntryPoint = "BusTools_Set1553Mode")]
      public static extern Int32 Set1553Mode
      (
         UInt32 cardnum,
         UInt32 rtMode
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_MessageBlockAlloc")]
      public static extern Int32 BC_MessageBlockAlloc
      (
         UInt32 cardnum,
         UInt32 bufID,
         UInt32 count
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_MessageBufferRead")]
      public static extern Int32 BC_MessageBufferRead
      (
         UInt32 cardnum,
         UInt32 addr,
         [In, Out] DataTypes.API_BC_MBUF pBC_mbuf
      );
//      [DllImport(dllPath, EntryPoint = "BusTools_BC_MessageUpdateBuffer")]
//      public static extern Int32 BC_MessageUpdateBuffer
//      (
//         UInt32 cardnum,
//         UInt32 mblockID,
//         UInt32 bufferID,
//         [In,Out] UInt16[] buffer
//      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_DataBufferUpdate")]
      public static extern Int32 BC_DataBufferUpdate
      (
         UInt32 cardnum,
         UInt32 bufAddr,
         UInt32 count,
         [In, Out] UInt16[] buffer
      );
      [DllImport(dllPath, EntryPoint = "BusTools_SetV6TrigOut")]
      public static extern Int32 SetV6TrigOut
      (
         UInt32 cardnum,
         Int32 trigOpt,
         UInt32 trigVal
      );
      [DllImport(dllPath, EntryPoint = "BusTools_SetV6TrigIn")]
      public static extern Int32 SetV6TrigIn
      (
         UInt32 cardnum,
         Int32 trigOpt,
         UInt32 trigVal
      );
      [DllImport(dllPath, EntryPoint = "BusTools_MemoryAvailable")]
      public static extern Int32 MemoryAvailable
      (
         UInt32 cardnum,
         ref UInt32 BytesAvailable
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_ReadDataBuffer")]
      public static extern Int32 BC_ReadDataBuffer
      (
         UInt32 cardnum,
         UInt32 bufAddr,
         [In, Out] UInt16[] buffer
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_SelectBufferRead")]
      public static extern Int32 BC_SelectBufferRead
      (
         UInt32 cardnum,
         UInt32 messageNumber,
         UInt32 bufNumber,
         [In, Out] UInt16[] buffer
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_SelectBufferUpdate")]
      public static extern Int32 BC_SelectBufferUpdate
      (
         UInt32 cardnum,
         UInt32 messageNumber,
         UInt32 bufNumber,
         UInt32 count,
         [In, Out] UInt16[] buffer
      );
      [DllImport(dllPath, EntryPoint = "BusTools_BC_GetBufferCount")]
      public static extern Int32 BC_GetBufferCount
      (
         UInt32 cardnum,
         UInt32 bufNumber,
         ref UInt32 count
      );
      [DllImport(dllPath, EntryPoint = "BusTools_TimeTagReset")]
      public static extern Int32 TimeTagReset
      (
         UInt32 cardnum,
         UInt32 flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_GetValidDiscrete")]
      public static extern Int32 GetValidDiscrete
      (
         UInt32 cardnum,
         ref UInt32 flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_GetValidPio")]
      public static extern Int32 GetValidPio
      (
         UInt32 cardnum,
         ref UInt32 flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_GetValidDiff")]
      public static extern Int32 GetValidDiff
      (
         UInt32 cardnum,
         ref UInt32 flag
      );
      [DllImport(dllPath, EntryPoint = "BusTools_SharedMemoryWrite")]
      public static extern Int32 SharedMemoryWrite
      (
         UInt32 cardnum,
         UInt32 addr,
         UInt32 byteCount,
         [Out] Byte[] byteArray
      );
      [DllImport(dllPath, EntryPoint = "BusTools_SharedMemoryRead")]
      public static extern Int32 SharedMemoryRead
      (
         UInt32 cardnum,
         UInt32 addr,
         UInt32 byteCount,
         [In, Out] Byte[] byteArray
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RS485_V6Ctrl")]
      public static extern Int32 RS485_V6Ctrl
      (
         UInt32 cardnum,
         UInt32 channel,
         UInt32 data,
         UInt32 txEnable,
         UInt32 termination
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RS485_V6Data")]
      public static extern Int32 RS485_V6Data
      (
         UInt32 cardnum,
         Int32 difFlag,
         ref UInt32 dData
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RelAddr")]
      public static extern Int32 RelAddr
      (
         UInt32 cardnum,
         UInt32 addr
      );
      [DllImport(dllPath, EntryPoint = "BusTools_RamAddr")]
      public static extern Int32 RamAddr
      (
         UInt32 cardnum,
         UInt32 addr
      );
      [DllImport(dllPath, EntryPoint = "BusTools_V6_SetDiscreteBlock")]
      public static extern Int32 V6_SetDiscreteBlock
      (
         UInt32 cardnum,
         UInt32 discreteValue
      );
   }
}
