using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Bustools1553
{
   public class Constants
   {
      public const UInt16 PLATFORM_PC   = 0x0;
      public const UInt16 PLATFORM_USER = 0x4;
      public const UInt16 PLATFORM_VMIC = 0x1;

      public const UInt16 PMC1553      = 0x20;
      public const UInt16 PCI1553      = 0x40;
      public const UInt16 CPCI1553     = 0x50;
      public const UInt16 ISA1553      = 0x80;
      public const UInt16 DT1553       = 0x90;
      public const UInt16 PCC1553      = 0xA0;
      public const UInt16 VME1553      = 0x100;
      public const UInt16 AMC1553      = 0x110;
      public const UInt16 QPM1553      = 0x110;
      public const UInt16 QPMC1553     = 0x110;
      public const UInt16 IPD1553      = 0x120;
      public const UInt16 VXI1553      = 0x140;
      public const UInt16 QPCI1553     = 0x160;
      public const UInt16 Q1041553     = 0x170;
      public const UInt16 Q1041553P    = 0x180;
      public const UInt16 QVME1553     = 0x190;
      public const UInt16 RQVME21553   = 0x190;
      public const UInt16 PCCD1553     = 0x200;
      public const UInt16 QCP1553      = 0x210;
      public const UInt16 QPCX1553     = 0x220;
      public const UInt16 R15EC        = 0x230;
      public const UInt16 R15AMC       = 0x240;    /* This is the R15-AMC (QPM1553 variant)     */
      public const UInt16 RPCIe1553    = 0x250;    /* This is the RPCIe-1553 PCI Express native */
      public const UInt16 RXMC1553     = 0x260;    /* This is the RXMC-1553                     */ 
      public const UInt16 R15XMC2      = 0x300;    /* This is the RXMC2-1553                    */
      public const UInt16 LPCIE1553    = 0x320;    /* This is the low profile PCI express       */
      public const UInt16 RAR15XMCXT   = 0x360;    /* This is the RAR15XMC extended Temp XMC    */
      public const UInt16 RAR15XMCIT   = 0x360;    /* This is the RAR15XMC Industrial Temp XMC  */
      public const UInt16 RAR15XMCFIO  = 0x360;    /* This is the RAR15XMC Front I/O XMC        */
      public const UInt16 R15PMC       = 0x380;    /* This is the R15-PMC                       */
      public const UInt16 MPCIE1553    = 0x400;    /* This is the mPCIE-1553, mini PCI Express  */
      public const UInt16 R15USB       = 0x3000;   /* This is the R15-USB                       */ 

      public const UInt16 NATIVE       = 0x0;
      public const UInt16 NATIVE_24    = 0x0;
      public const UInt16 NATIVE_32    = 0x4;

      public const UInt16 CHANNEL_1    = 0;
      public const UInt16 CHANNEL_2    = 1;
      public const UInt16 CHANNEL_3    = 2;
      public const UInt16 CHANNEL_4    = 3;

      public const UInt16 CARRIER_MAP_DEFAULT = 0x0;
      public const UInt16 CARRIER_MAP_SMALL   = 0x1;
      public const UInt16 CARRIER_MAP_LARGE   = 0x2;
      public const UInt16 CARRIER_MAP_A32     = 0x10;   /* Native VME - A32 Addressing        */
      public const UInt16 CARRIER_MAP_A24     = 0x11;   /* Native VME - A24 Addressing        */
      public const UInt16 CARRIER_MAP_A16     = 0x12;   /* Native VME - A16 Addressing        */
      public const UInt16 CARRIER_MAP_A24S    = 0x13;   /* Native VME - A24 VxWorks SUP DATA Addressing */
      public const UInt16 CARRIER_MAP_A32S    = 0x14;   /* Native VME - A32 VxWorks SUP DATA Addressing */
      public const UInt16 CARRIER_MAP_A24SP   = 0x15;   /* Native VME - A24 VxWorks SUP PGM Addressing */
      public const UInt16 CARRIER_MAP_A32SP   = 0x16;   /* Native VME - A32 VxWorks SUP PGM Addressing */
      public const UInt16 CARRIER_MAP_A32UP   = 0x17;   /* Native VME - A32 VxWorks USR PGM Addressing */ 
      public const UInt16 CARRIER_MAP_A24UP   = 0x18;   /* Native VME - A24 VxWorks USR PGM Addressing */ 

      public const UInt16 WAIT   = 1;
      public const UInt16 NOWAIT = 0;

      public const Int32 API_DEMO_MODE     = 0x0;
      public const Int32 API_SW_INTERRUPT  = 0x1;
      public const Int32 API_HW_INTERRUPT  = 0x2;
      public const Int32 API_HW_ONLY_INT   = 0x3;
      public const Int32 API_INT_MASK      = 0x3f;
	  
      public const Int32 API_B_MODE        = 0x0;
      public const Int32 API_A_MODE        = 0x80;

      public const Int32 API_VXW_HLI       = 0x10;
      public const Int32 API_MANUAL_INT    = 0x20;
      public const Int32 API_CHANNEL_MAP   = 0x40;

      public const Int32 API_MODE_MASK        = 0xf0;
      public const Int32 API_NO_MEM_TST       = 0x800;
      public const Int32 API_CONT_ON_MEM_FAIL = 0x400;

      public const UInt16 ITRIGGER_OUT_DIS_7 = 0x1;
      public const UInt16 ITRIGGER_OUT_DIS_8 = 0x2;
      public const UInt16 ITRIGGER_OUT_NONE  = 0x0;
      public const UInt16 TRIGGER_IN_NONE    = 0x0;
      public const UInt16 TRIGGER_IN_485     = 0x1;
      public const UInt16 TRIGGER_IN_DIS_7   = 0x2;
      public const UInt16 TRIGGER_IN_DIS_8   = 0x3;

      public const UInt32 RS485_TXEN_REG = 0x0;
      public const UInt32 RS485_TXDA_REG = 0x1;
      public const UInt32 RS485_RXDA_REG = 0x2;

      public const UInt16 EXT_TRIG_ENABLE  = 1;
      public const UInt16 EXT_TRIG_DISABLE = 0;
	  
      public const UInt32 TRANSFORMER = 1;	  
      public const UInt32 DIRECT      = 0;	  
	  
//      public const Int32 TEST_BUS_ENABLE  = 0x1000;
//      public const Int32 TEST_BUS_DISABLE = ~TEST_BUS_ENABLE;
      public const UInt32 TEST_BUS_ENABLE = 0x1000;
      public const UInt32 TEST_BUS_DISABLE = ~TEST_BUS_ENABLE;
	  
      public const UInt32 PCI_RESET_ENABLE  = 1;
      public const UInt32 PCI_RESET_DISABLE = 0;

      public const UInt32 VME_RESET_ENABLE  = 1;
      public const UInt32 VME_RESET_DISABLE = 0;
    
      public const UInt32 INTERNAL_BUS = 1;
      public const UInt32 EXTERNAL_BUS = 0;

      public const UInt32 REL_GAP             = 0x0;
      public const UInt32 FRAME_MESSAGING     = 0x0;
      public const UInt32 FIXED_GAP           = 0xf;
      public const UInt32 MSG_SCHD            = 0x10;
      public const UInt32 NO_PRED_LOGIC       = 0x40;
      public const UInt32 FRAME_START_TIMING  = 0x20;
      public const UInt32 MULTIPLE_BC_BUFFERS = 0x80;
      public const UInt32 MFOVFL_INT_ENA      = 0x100;
      public const UInt32 NO_BC_RETRY         = 0;
      public const UInt32 NO_INTERUPT         = 0;
      public const UInt16 RECEIVE             = 0;
      public const UInt16 TRANSMIT            = 1;


      
      



      
      
      public const UInt16 BT1553_INT_HIGH_WORD        = 0x1;
      public const UInt16 BT1553_INT_BIT_COUNT_DATA   = 0x1;
      public const UInt16 BT1553_INT_INVALID_WORD     = 0x2;
      public const UInt16 BT1553_INT_LOW_WORD         = 0x4;
      public const UInt16 BT1553_INT_INVERTED_SYNC    = 0x8;
      public const UInt16 BT1553_INT_MID_BIT          = 0x10;
      public const UInt16 BT1553_INT_MID_SYNC         = 0x20;
      public const UInt16 BT1553_INT_TWO_BUS          = 0x20;
      public const UInt16 BT1553_INT_PARITY           = 0x40;
      public const UInt16 BT1553_INT_NON_CONT_DATA    = 0x80;
      public const UInt16 BT1553_INT_EARLY_RESP       = 0x100;
      public const UInt16 BT1553_INT_LATE_RESP        = 0x200;
      public const UInt16 BT1553_INT_BAD_RTADDR       = 0x400;
      public const UInt16 BT1553_INT_CHANNEL          = 0x800;
      
      public const UInt16 BT1553_INT_WRONG_BUS        = 0x2000;
      public const UInt16 BT1553_INT_BIT_COUNT        = 0x4000;
      public const UInt16 BT1553_INT_NO_IMSG_GAP      = 0x8000;
      public const UInt32 BT1553_INT_END_OF_MESS      = 0x10000;
      public const UInt32 BT1553_INT_BROADCAST        = 0x20000;
      public const UInt32 BT1553_INT_RT_RT_FORMAT     = 0x40000;
      public const UInt32 BT1553_INT_RESET_RT         = 0x80000;
      public const UInt32 BT1553_INT_SELF_TEST        = 0x100000;
      public const UInt32 BT1553_INT_MODE_CODE        = 0x200000;
      public const UInt32 BT1553_INT_BIT_FAILURE      = 0x200000;
      public const UInt32 BT1553_INT_INVALID_COMM     = 0x400000;
      public const UInt32 BT1553_INT_NOCMD            = 0x400000;
      public const UInt32 BT1553_INT_RT_RT_TIMEOUT    = 0x800000;
      public const UInt32 BT1553_INV_RTRT_TX          = 0x800000;
      public const UInt32 BT1553_INT_NA1000000        = 0x1000000;
      public const UInt32 BT1553_RTRT_RCV_NRSP        = 0x1000000;
      public const UInt32 BT1553_INT_RETRY            = 0x2000000;
      public const UInt32 BT1553_INT_NO_RESP          = 0x4000000;
      public const UInt32 BT1553_INT_ERROR_BIT        = 0x8000000;
      public const UInt32 BT1553_INT_ME_BIT           = 0x8000000;
      public const UInt32 BT1553_INT_TRIG_BEGIN       = 0x10000000;
      public const UInt32 BT1553_INT_TRIG_END         = 0x20000000;
      public const UInt32 BT1553_INT_BM_OVERFLOW      = 0x40000000;
      public const UInt32 BT1553_INT_ALT_BUFFER       = 0x80000000;
      public const UInt32 BT1553_INT_ALT_BUS          = 0x80000000;	  

      public const UInt16 BT1553_BUFCOUNT = 34;

	  

      public const UInt16 BC_CONTROL_NOP        = 0x0;
      public const UInt16 BC_CONTROL_MESSAGE    = 0x1;
      public const UInt16 BC_CONTROL_BRANCH     = 0x2;
      public const UInt16 BC_CONTROL_CONDITION  = 0x3;
      public const UInt16 BC_CONTROL_CONDITION2 = 0x4;
      public const UInt16 BC_CONTROL_LAST       = 0x5;
      public const UInt16 BC_CONTROL_HALT       = 0x8005;
      public const UInt16 BC_CONTROL_CONDITION3 = 0x6;
      public const UInt16 BC_CONTROL_MSG_NOP    = 0x7;
      public const UInt16 BC_CONTROL_TYPEMASK   = 0x7;
      public const UInt16 BC_CONTROL_MFRAME_BEG = 0x8;
      public const UInt16 BC_CONTROL_MFRAME_END = 0x10;
      public const UInt16 BC_CONTROL_RTRTFORMAT = 0x20;
      public const UInt16 BC_CONTROL_RETRY      = 0x40;
      public const UInt16 BC_CONTROL_INTERRUPT  = 0x80;
      public const UInt16 BC_CONTROL_BUFFERA    = 0x100;
      public const UInt16 BC_CONTROL_BUFFERB    = 0x200;
      public const UInt16 BC_CONTROL_CHANNELA   = 0x400;
      public const UInt16 BC_CONTROL_CHANNELB   = 0x800;
      public const UInt16 BC_CONTROL_BUSA       = 0x400;
      public const UInt16 BC_CONTROL_BUSB       = 0x800;
      public const UInt16 BC_CONTROL_PINGPONG   = 0x1000;
      public const UInt16 BC_CONTROL_INTQ_ONLY  = 0x1000;
      public const UInt16 BC_CONTROL_USEBUFFA   = 0x2000;
      public const UInt16 BC_CONTROL_TIMED_NOP  = 0x2000;

      public const UInt16 BC_TRIGGER_IMMEDIATE  = 0;
      public const UInt16 BC_TRIGGER_ONESHOT    = 1;
      public const UInt16 BC_TRIGGER_USER       = 2;
      public const Int16  BC_TRIGGER_REPETITIVE = -1;	  
	  
      public const UInt16 RETRY_ALTERNATE_BUS = 2;
      public const UInt16 RETRY_SAME_BUS      = 1;
      public const UInt16 RETRY_END           = 0;

      public const UInt16 BC_RETRY_TF    = 0x1;
      public const UInt16 BC_RETRY_SSF   = 0x2;
      public const UInt16 BC_RETRY_BUSY  = 0x4;
      public const UInt16 BC_RETRY_SRQ   = 0x8;
      public const UInt16 BC_RETRY_INSTR = 0x10;
      public const UInt16 BC_RETRY_ME    = 0x20;
      public const UInt16 BC_RETRY_ALTB  = 0x8888;

      public const UInt16 BC_RETRY_INV_WRD    = 0x40;
      public const UInt16 BC_RETRY_INV_SYNC   = 0x80;
      public const UInt16 BC_RETRY_MID_BIT    = 0x100;
      public const UInt16 BC_RETRY_TWO_BUS    = 0x200;
      public const UInt16 BC_RETRY_PARITY     = 0x400;
      public const UInt16 BC_RETRY_CONT_DATA  = 0x800;
      public const UInt16 BC_RETRY_EARLY_RSP  = 0x1000;
      public const UInt16 BC_RETRY_LATE_RSP   = 0x2000;
      public const UInt16 BC_RETRY_BAD_ADDR   = 0x4000;
      public const UInt16 BC_RETRY_WRONG_BUS  = 0x8000;
      public const UInt32 BC_RETRY_NO_GAP     = 0x10000;
      public const UInt32 BC_RETRY_NRSP_RCV   = 0x20000;
      public const UInt32 BC_RETRY_NRSP       = 0x40000;
      public const UInt32 BC_RETRY_BIT_COUNT  = 0x40000;

      public const UInt16 BM_ADDRESS_COUNT   = 32;
      public const UInt16 BM_SUBADDR_COUNT   = 32;
      public const UInt16 BM_TRANREC_COUNT   = 2;

      public const UInt16 BM_SUBUNIT_COUNT   = 2048;
      public const UInt16 BM_FILTER_MC_DBC   = 0x1;
      public const UInt16 BM_FILTER_MC_SYNC  = 0x2;
      public const UInt16 BM_FILTER_MC_TSWS  = 0x4;
      public const UInt16 BM_FILTER_MC_STST  = 0x8;
      public const UInt16 BM_FILTER_MC_XSD   = 0x10;
      public const UInt16 BM_FILTER_MC_OXSD  = 0x20;
      public const UInt16 BM_FILTER_MC_ITF   = 0x40;
      public const UInt16 BM_FILTER_MC_OITF  = 0x80;
      public const UInt16 BM_FILTER_MC_RRT   = 0x100;
      public const UInt32 BM_FILTER_MC_TVWC  = 0x10000;
      public const UInt32 BM_FILTER_MC_SWO   = 0x20000;
      public const UInt32 BM_FILTER_MC_TLC   = 0x40000;
      public const UInt32 BM_FILTER_MC_TBW   = 0x80000;
      public const UInt32 BM_FILTER_MC_SXSD  = 0x100000;
      public const UInt32 BM_FILTER_MC_OSXS  = 0x200000;
	  
      public const UInt16 BM_CBUF_ENABLE   = 0x1;
      public const UInt16 BM_CBUF_INTERACT = 0x2;
      public const UInt16 BM_CBUF_RECORD   = 0x4;
      public const UInt16 BM_CBUF_SBUFF    = 0x8;	  
	  
      public const UInt16 BT1553_MBUFCOUNT = 32;
	  
      public const UInt16 INT_QUE_PTR_REG  = 166;	  
	  
      public const UInt16 EI_COUNT = 33;	  

      public const UInt16 EI_BC_REC    = 0;
      public const UInt16 EI_BC_TRANS  = 1;
      public const UInt16 EI_BC_RTTORT = 2;
      public const UInt16 EI_RT_REC    = 3;
      public const UInt16 EI_RT_TRANS  = 4;
	  
      public const UInt16 EI_NONE            = 0;
      public const UInt16 EI_TWOBUS          = 1;
      public const UInt16 EI_PARITY          = 2;
      public const UInt16 EI_MIDSYNC         = 3;
      public const UInt16 EI_MIDBIT          = 4;
      public const UInt16 EI_BITCOUNT        = 5;
      public const UInt16 EI_WORDCOUNT       = 6;
      public const UInt16 EI_SYNC            = 7;
      public const UInt16 EI_DATAWORDGAP     = 8;
      public const UInt16 EI_LATERESPONSE    = 9;
      public const UInt16 EI_VAROUTVOLT      = 10;
      public const UInt16 EI_RESPWRONGBUS    = 11;
      public const UInt16 EI_NOINTERMSGGAP   = 12;
      public const UInt16 EI_BADADDR         = 13;
      public const UInt16 EI_MIDPARITY       = 14;
      public const UInt16 EI_BIPHASE         = 15;
	  
      public const UInt16 RT_ADDRESS_COUNT   = 32;
      public const UInt16 RT_SUBADDR_COUNT   = 32;
      public const UInt16 RT_TRANREC_COUNT   = 2;
      public const UInt16 RT_SUBUNIT_COUNT   = 2048;	  

      public const UInt16 RT_ABUF_MON_ENA    = 0x1;
      public const UInt16 RT_ABUF_DBC_ENA    = 0x2;
      public const UInt16 RT_ABUF_ITF        = 0x4;
      public const UInt16 RT_ABUF_MBUF_BWD   = 0x10;
      public const UInt16 RT_ABUF_EXT_STATUS = 0x100;
      public const UInt16 RT_ABUF_DBC_RT_OFF = 0x8000;

      public const Int32 REGISTER_FUNCTION   = 1;
      public const Int32 UNREGISTER_FUNCTION = 0;
	  
      public const UInt16 MAX_FIFO_LEN       = 256;	  
	  
      public const UInt16 CALL_STARTUP       = 0x1;
      public const UInt16 CALL_SHUTDOWN      = 0x4;

      public const UInt32 EVENT_IMMEDIATE   = 0x000f;
      public const UInt32 EVENT_EXT_TRIG    = 0x0001;
      public const UInt32 EVENT_TIMER_WRAP  = 0x0002;    /* Tag Timer overflow or discrete input   */
      public const Int32  EVENT_RT_MESSAGE  = 0x0004;    /* RT message transacted                  */
      public const Int32  EVENT_BM_MESSAGE  = 0x0008;    /* BM message transacted                  */
      public const Int32  EVENT_BC_MESSAGE  = 0x0010;    /* BC message transacted                  */
      public const UInt32 EVENT_BM_TRIG     = 0x0020;    /* BM trigger event (start/stop)          */
      public const UInt32 EVENT_BM_START    = 0x0040;    /* BM started (BusTools_BM_StartStop)V4.01*/
      public const UInt32 EVENT_BM_STOP     = 0x0080;    /* BM stopped (BusTools_BM_StartStop)     */
          
      public const UInt32 EVENT_BC_START    = 0x0100;    /* BC started (BusTools_BC_StartStop)     */
      public const UInt32 EVENT_BC_STOP     = 0x0200;    /* BC stopped (BusTools_BC_StartStop)     */
      public const UInt32 EVENT_RT_START    = 0x0400;    /* BC started (BusTools_RT_StartStop)     */
      public const UInt32 EVENT_RT_STOP     = 0x0800;    /* BC stopped (BusTools_RT_StartStop)     */

      public const UInt32 EVENT_RECORDER    = 0x1000;    /* BM recorder buffer has 64K or timeout  */
      public const UInt32 EVENT_MF_OVERFLO  = 0x2000;    /* Minor frame timing overflow            */
      public const UInt32 EVENT_API_OVERFLO = 0x4000;    /* BM API Recorder buffer overflowed      */
      public const UInt32 EVENT_HW_OVERFLO  = 0x8000;    /* BM HW Recorder buffer overflowed       */
      public const UInt32 EVENT_BC_CONTROL  = 0x10000;   /* BC Control block (NOOP condition stop) */
      public const UInt32 EVENT_LP_MF_OVFL  = 0x020000;  /* Low Priority Minor Frame overflow      */
      public const UInt32 EVENT_HP_MF_OVFL  = 0x040000;  /* Hi  Priority Minor Frame overflow      */
      public const UInt32 EVENT_BC_BSY_OVFL = 0x080000;  /* BC Busy overflow                       */
      public const UInt32 EVENT_BM_OVRFLW   = 0x100000;  /* BM overflow                            */

      public const UInt16 API_1553_STAT_ME = 0x400;
      public const UInt16 API_1553_STAT_IN = 0x200;
      public const UInt16 API_1553_STAT_SR = 0x100;
      public const UInt16 API_1553_STAT_BR = 0x10;
      public const UInt16 API_1553_STAT_BY = 0x8;
      public const UInt16 API_1553_STAT_SF = 0x4;
      public const UInt16 API_1553_STAT_DB = 0x2;
      public const UInt16 API_1553_STAT_TF = 0x1;

      public const UInt16 GETADDR_HWREG      = 1;
      public const UInt16 GETADDR_RAMREG     = 2;
      public const UInt16 GETADDR_BCMESS     = 3;
      public const UInt16 GETADDR_BMFILTER   = 4;
      public const UInt16 GETADDR_BMTRIGGER  = 5;
      public const UInt16 GETADDR_BMMESSAGE  = 6;
      public const UInt16 GETADDR_BMCONTROL  = 7;
      public const UInt16 GETADDR_BMDEFCBUF  = 8;
      public const UInt16 GETADDR_RTADDRESS  = 9;
      public const UInt16 GETADDR_RTFILTER   = 10;
      public const UInt16 GETADDR_RTDATA     = 11;
      public const UInt16 GETADDR_EI         = 12;
      public const UInt16 GETADDR_IQ         = 13;
      public const UInt16 GETADDR_RTMBUF_DEF = 14;
      public const UInt16 GETADDR_RTCBUF_DEF = 15;
      public const UInt16 GETADDR_RTCBUF_BRO = 16;
      public const UInt16 GETADDR_PCI_RTDATA = 17;
      public const UInt16 GETADDR_DIFF_IO    = 18;
      public const UInt16 GETADDR_COUNT      = 18;	  
	  
      public const UInt32 DUMP_HWREG      = 1 << GETADDR_HWREG;       // Hardware Registers             
      public const UInt32 DUMP_RAMREG     = 1 << GETADDR_RAMREG;      // RAM Registers             
      public const UInt32 DUMP_BCMESS     = 1 << GETADDR_BCMESS;      // BC Message Buffers            
      public const UInt32 DUMP_BMFILTER   = 1 << GETADDR_BMFILTER;    // BM Filter Buffer              
      public const UInt32 DUMP_BMTRIGGER  = 1 << GETADDR_BMTRIGGER;   // BM Trigger Buffer             
      public const UInt32 DUMP_BMMESSAGE  = 1 << GETADDR_BMMESSAGE;   // BM Message Buffers             
      public const UInt32 DUMP_BMCONTROL  = 1 << GETADDR_BMCONTROL;   // BM Control Buffers             
      public const UInt32 DUMP_BMDEFCBUF  = 1 << GETADDR_BMDEFCBUF;   // BM Default Control Buffer     
      public const UInt32 DUMP_RTADDRESS  = 1 << GETADDR_RTADDRESS;   // RT Address Buffer   
      public const UInt32 DUMP_RTFILTER   = 1 << GETADDR_RTFILTER;    // RT Filter Buffer   
      public const UInt32 DUMP_RTDATA     = 1 << GETADDR_RTDATA;      // RT Control and Message Buffers 
      public const UInt32 DUMP_EI         = 1 << GETADDR_EI;          // Error Injection data area  
      public const UInt32 DUMP_IQ         = 1 << GETADDR_IQ;          // Interrupt queue data area    
      public const UInt32 DUMP_RTMBUF_DEF = 1 << GETADDR_RTMBUF_DEF;  // RT Default Message Buffers   
      public const UInt32 DUMP_RTCBUF_DEF = 1 << GETADDR_RTCBUF_DEF;  // RT Default Control Buffers 
      public const UInt32 DUMP_RTCBUF_BRO = 1 << GETADDR_RTCBUF_BRO;  // RT Broadcast Control Buffers  
      public const UInt32 DUMP_PCI_RTDATA = 1 << GETADDR_PCI_RTDATA;  // RT MBUF's, PCI-1553 only  
      public const UInt32 DUMP_DIFF_IO    = 1 << GETADDR_DIFF_IO;     // Discrete IO registers  
      public const UInt32 DUMP_ALL        = 0xffffffff;
      public const UInt32 DUMP_RT         = DUMP_RTFILTER | DUMP_RTADDRESS | DUMP_RTDATA | DUMP_RTMBUF_DEF | DUMP_RTCBUF_DEF | DUMP_RTCBUF_BRO | DUMP_PCI_RTDATA;





/**********************************************************************
	Register defines for V6 boards
**********************************************************************/
      public const UInt32 P1_FRONT_IO_CONNECTOR = 0x1;
      public const UInt32 P14_REAR_IO_CONNECTOR = 0x2;
      public const UInt32 P16_READ_IO_CONNECTOR = 0x4;

/************************************************************************
* Global Register WORD offsets  HIF  V6 Boards
************************************************************************/
      public const UInt32 GLBREG_CSC_OFFSET     = 0x0;
      public const UInt32 GLBREG_BD_SPECIFIC    = 0x1;
      public const UInt32 GLBREG_RTADDR1        = 0x2;
      public const UInt32 GLBREG_RTADDR2        = 0x3;
      public const UInt32 GLBREG_CH1_OPT        = 0x4;
      public const UInt32 GLBREG_CH2_OPT        = 0x5;
      public const UInt32 GLBREG_CH3_OPT        = 0x6;
      public const UInt32 GLBREG_CH4_OPT        = 0x7; 
      public const UInt32 GLBREG_CH5_OPT        = 0x8; 
      public const UInt32 GLBREG_CH6_OPT        = 0x9; 
      public const UInt32 GLBREG_CH7_OPT        = 0xa; 
      public const UInt32 GLBREG_CH8_OPT        = 0xb;
      public const UInt32 GLBREG_BD_SERIAL_NUM  = 0xc; 
      public const UInt32 GLBREG_DISCR_OPT      = 0xd;
      public const UInt32 GLBREG_DIFF_OPT       = 0xe;
      public const UInt32 GLBREG_PIO_OPT        = 0xf;

      public const UInt32 GLBREG_FPGA_REV       = 0x20;
      public const UInt32 GLBREG_INT_STAT       = 0x21;
      public const UInt32 GLBREG_RAMSTART       = 0x22;
      public const UInt32 GLBREG_RAMSIZE        = 0x23;
      public const UInt32 GLBREG_LED_CTL        = 0x24;
      public const UInt32 GLBREG_TMP_SEN_READ   = 0x25;
      public const UInt32 GLBREG_TMP_SEN_WRITE  = 0x26;
      public const UInt32 GLBREG_RESET_ENABLE   = 0x27;
      public const UInt32 GLBREG_DISC_OUT       = 0x30;
      public const UInt32 GLBREG_DSIC_IN        = 0x31;
      public const UInt32 GLBREG_RS485_CTL      = 0x32;
      public const UInt32 GLBREG_RS485_DATA     = 0x33;
      public const UInt32 GLBREG_EXT_RT_ADDR    = 0x34;
      public const UInt32 GLBREG_DAC_CTRL       = 0x36;
      public const UInt32 GLBREG_PIO_CTRL       = 0x37;

      public const UInt32 GLBREG_IRIG_CTRL      = 0x50;
      public const UInt32 GLBREG_IRIG_TOY       = 0x51;
      public const UInt32 GLBREG_RESET_TT       = 0x52;

/************************************************************************
*  V6 Hardware register WORD offsets;  32-BIT word address HWREG
************************************************************************/
/* 0x10 - 0x4F Common Registers  */
      public const UInt32 HWREG_LPU_V6REVISION  = 0x10;  // Read LPU Revision information              (R)
      public const UInt32 HWREG_BUILD_NUMBER    = 0x11;  // Build Number                               (R)
      public const UInt32 HWREG_WCS_V6REVISION  = 0x12;  // Microcode Revision register                (R)
      public const UInt32 HWREG_WCS_BUILD       = 0x13;  // Microcode Build Number                     (R)
      public const UInt32 HWREG_HEART_BEATV6    = 0x14;  // Heart Beat Register                        (R)
/* 0x15 reserved */
      public const UInt32 HWREG_CONTROL         = 0x16;  // 1553 Control Reg. bits 31:0                (R/W)
      public const UInt32 HWREG_1553A_ENABLE    = 0x18;  // Mil-Std-1553A Enables Register             (R/W)
      public const UInt32 HWREG_V6RESPONSE      = 0x1a;  // response time out/late response            (R/W)
/* 0x1b - 0x2f reserved */
      public const UInt32 HWREG_FW_CNTRL        = 0x30;  // Firmware Control Flags                     (R/W)
/* 0x31 - 0x37 Reserved */
/* 0x38 - 0x3f Interrupt Queue Registers */ 
      public const UInt32 HWREG_IQ_BUF_START    = 0x3a;  // Interrupt Queue Buffer Start Pointer       (R/W)
      public const UInt32 HWREG_IQ_BUF_END      = 0x3b;  // Interrupt Queue Puffer End Pointer         (R/W)
      public const UInt32 HWREG_IQ_HEAD_PTR     = 0x3c;  // Interrupt Queue Head Pointer               (R/W)
/* 0x3d - 0x3f Not Used */
/* 0x40 - 0x67 Bus Controller Control Registers */
      public const UInt32 HWREG_BCMSG_PTR       = 0x40;  // BC Message Initial Word Pointer            (R/W)
      public const UInt32 HWREG_BC_INT_ENABLE   = 0x41;  // BC Interrupt Enables                       (R/W)
      public const UInt32 HWREG_MINOR_FRAMEV6   = 0x42;  // BC Minor Frame Register                    (R/W)
/* 0x43 reserved  */
      public const UInt32 HWREG_BC_RETRY        = 0x44;  // BC Retry Enable Bits                       (R/W)
      public const UInt32 HWREG_DQ_RETRY        = 0x45;  // Rettry on Data Quality                     (R/W)
      public const UInt32 HWREG_BC_RETRY_CTL    = 0x46;  // BC Retry Control Buffer                    (R/W)
/* 0x47 Reserved */
      public const UInt32 HWREG_BC_BUS_SWTCH    = 0x48;  // BC Bus Switching offset                    (R/W)
      public const UInt32 HWREG_BC_TRIGGER      = 0x49;  // BC Trigger setup                           (R/W)
      public const UInt32 HWREG_BC_HIGH_PRI_MSG = 0x4a;  // BC High Priority Aperiodic Message Pointer (R/W)
      public const UInt32 HWREG_BC_LOW_PRI_MSG  = 0x4b;  // BC Low Priority Aperiodic Message Pointer  (R/W)
/* 0x4c reserved  */
      public const UInt32 HWREG_BC_APER_FLAG    = 0x4d;  // BC Low Aperiodic List Flag                 (R/W)
/* 0x4f - 0x5f Reserved */
/* 0x60 - 0x77 Remote Terminal Control Registers */
      public const UInt32 HWREG_RT_HW_ADDR      = 0x60;  // RT Hard-Wired Address                      (R)
      public const UInt32 HWREG_SRT_V6ADDR      = 0x61;  // RT Address for Single-RT Mode              (R/W)
      public const UInt32 HWREG_RT_ENABLEA      = 0x62;  // RT 31..0 bus A enables                     (R/W)
      public const UInt32 HWREG_RT_ENABLEB      = 0x63;  // RT 31..0 bus B enables                     (R/W)
      public const UInt32 HWREG_RT_FILTER       = 0x64;  // RT Filter Buffer Base Address              (R/W)
/* 0x65 reserved         */
      public const UInt32 HWREG_RT_MSG_PTR_XMT  = 0x66;  // RT Message Transmit Word Pointer           (R/W)
      public const UInt32 HWREG_RT_MSG_PTR_RCV  = 0x67;  // RT Message Receive Word Pointer            (R/W)
/* 0x68 - 0x74 Reserved  */
      public const UInt32 HWREG_BCR_REG         = 0x74;  // BCR Register                               (R/W)                              
      public const UInt32 HWREG_ME_REG          = 0x75;  // ME Register                                (R/W)
/* 0x76 - 0x77 Reserved */
      public const UInt32 HWREG_BSY_REG         = 0x78;  // BSY Register                               (R/W)         
/* 0x76 - 0x7f Reserved  */
      public const UInt32 HWREG_RT_ABUF_ADDR    = 0x80;  // 0x080 - 0xbf RT Abuf 
/***************************************************************************************
 * 0xc0 - 0xd3 Bus Monitor Control Regiseters                                          *
 ***************************************************************************************/
      public const UInt32 HWREG_BM_BUF_START    = 0xc0;  // BM Start of Buffer Pointer A               (R/W)
      public const UInt32 HWREG_BM_BUF_END      = 0xc1;  // BM End of Buffer Pointer A                 (R/W)
      public const UInt32 HWREG_BM_HEAD_PTR     = 0xc2;  // BM Head Pointer                            (R/W)
      public const UInt32 HWREG_BM_TAIL_PTR     = 0xc3;  // BM Tail Pointer                            (R/W)
      public const UInt32 HWREG_BM_FILTER       = 0xc4;  // BM Filter Buffer Base Address              (R/W)
      public const UInt32 HWREG_BM_TRIGGER      = 0xc5;  // BM Trigger Buffer Pointer                  (R/W)
      public const UInt32 HWREG_BM_INT_ENABLE   = 0xc6;  // BM Interrupt enable                        (R/W)
/* 0xc7 - 0xd0 Reserved */
      public const UInt32 HWREG_BM_OVFL_CTR     = 0xd1;  // BM overflow counter (words) register       (R/W)
      public const UInt32 HWREG_BM_CTRL         = 0xd2;  // Enable/Disable BM hardware interrupts      (R/W)
/***************************************************************************************/
/* 0x90 - 0x93 Interrupt Queue Registers */
      public const UInt32 HWREG_PB_V6CONTROL    = 0xd4;  // Playback Control Register                  (RW)
/* 0xd6 - 0xd7 Reserved */
      public const UInt32 PB_START_V6POINTER    = 0xd8;  // Address of Playback Data Buffer
      public const UInt32 PB_END_V6POINTER      = 0xd9;  // End of Playback Data Buffer
      public const UInt32 PB_TAIL_V6POINTER     = 0xda;  // Current FW loc in PB Data Buffer
      public const UInt32 PB_HEAD_V6POINTER     = 0xdb;  // Addr where host is adding data
      public const UInt32 PB_THRSHLD_V6CNT      = 0xdc;  // Interrupt counter used by FW
      public const UInt32 PB_INT_V6STATUS       = 0xdd;  // Number of FW interrupts generated
      public const UInt32 PB_INT_V6THRSHLD      = 0xde;  // Number of words between FW interrupts
      public const UInt32 PB_CURRENT_V6WORD     = 0xdf;  // Reserved for the Playback firmware

      public const UInt32 PB_SET                = 0x80000000;
      public const UInt32 PB_CLEAR              = 0x40000000;
/* 0xe0 - 0xff Reserved */

      public const UInt32 HWREG_V6COUNT         = 0x100;


/* V6 Discrete Registers offset */
      public const UInt32 V6_DISCRETE_OUT       = 0x30;
      public const UInt32 V6_DISCRETE_IN        = 0x31;
      public const UInt32 V6_RS485_CTRL         = 0x32;
      public const UInt32 V6_RS485_DATA         = 0x33;
      public const UInt32 V6_EXT_RTADDR         = 0x34;
      public const UInt32 V6_DAC_CTRL           = 0x36;
      public const UInt32 V6_TRIGGER_CTRL       = 0x0;

/* BC message buffer offsets              */
      public const UInt32 BC_MESSNO_OFFSET            = 0;     //0
      public const UInt32 BC_NUM_BUFFERS_OFFSET       = 4;     //4
      public const UInt32 BC_CTLWD_OFFSET             = 8;     //8
      public const UInt32 BC_MSG_CMD1_OFFSET          = 12;    //c 
      public const UInt32 BC_MSG_CMD2_OFFSET          = 14;    //e   
      public const UInt32 BC_MSG_EI_OFFSET            = 16;    //10  
      public const UInt32 BC_MSG_DATA_OFFSET          = 20;    //14
      public const UInt32 BC_MSG_GAP_TIME_OFFSET      = 24;    //18
      public const UInt32 BC_MSG_REP_RATE_OFFSET      = 28;    //1c
      public const UInt32 BC_MSG_STR_FRAME_OFFSET     = 30;    //1e
      public const UInt32 BC_BRNCH_MSG_OFFSET         = 24;    //18
      public const UInt32 BC_MSG_NEXT_OFFSET          = 32;    //20 

/* BC Data byte offsets                    */
      public const UInt32 BC_DATA_MSG_OFFSET          = 0;
      public const UInt32 BC_DATA_NEXT_OFFSET         = 4;
      public const UInt32 BC_DATA_TTIME_OFFSET        = 8;
      public const UInt32 BC_DATA_STATUS_OFFSET       = 16;
      public const UInt32 BC_DATA_MSTAT1_OFFSET       = 20;
      public const UInt32 BC_DATA_MSTAT2_OFFSET       = 22;
      public const UInt32 BC_DATA_DATA_OFFSET         = 24;

/* BC Control data offset                 */
      public const UInt32 BC_CTRLDATA_MSG_OFFSET      = 0;
      public const UInt32 BC_CTRLDATA_NXT_DATA_OFFSET = 4;
      public const UInt32 BC_CTRLDATA_TTIME_OFFSET    = 8;
      public const UInt32 BC_CTRLDATA_TST_WRD_OFFSET  = 16;
      public const UInt32 BC_CTRLDATA_DATA_OFFSET     = 20;
      public const UInt32 BC_CTRLDATA_BIT_MSK_OFFSET  = 24;
      public const UInt32 BC_CTRLDATA_COND_CTR_OFFSET = 28;
      public const UInt32 BC_CTRLDATA_CTR_VAL_OFFSET  = 32;
      public const UInt32 BC_CTRLDATA_NXT_MSG_ADDR    = 36;
      public const UInt32 BC_CTRLDATA_RESERVED        = 40;

/* BM Buffer word offset defines */
      public const UInt32 BM_HEADER_OFFSET            = 0;
      public const UInt32 BM_INT_STATUS_OFFSET        = 4;
      public const UInt32 BM_TIME_TAG_OFFSET          = 8;
      public const UInt32 BM_CMD1_OFFSET              = 16;
      public const UInt32 BM_CMD2_OFFSET              = 20;
      public const UInt32 BM_RESP1_OFFSET             = 24;
      public const UInt32 BM_STAT1_OFFSET             = 28;
      public const UInt32 BM_RESP2_OFFSET             = 32;
      public const UInt32 BM_STAT2_OFFSET             = 36;
      public const UInt32 BM_DATA_START               = 40;

/* RT Message buffer word offset.  */
      public const UInt32 RT_NXT_MSG_OFFSET           = 0;
      public const UInt32 RT_EI_PTR_OFFSET            = 4;
      public const UInt32 RT_ENABLE_OFFSET            = 8;
      public const UInt32 RT_INT_STATUS_OFFSET        = 12;
      public const UInt32 RT_TIME_TAG_OFFSET          = 16;
      public const UInt32 RT_CMD_OFFSET               = 24;
      public const UInt32 RT_STATUS_OFFSET            = 26;
      public const UInt32 RT_DATA_OFFSET              = 28;
      public const UInt32 RT_EXT_STAT_OFFSET          = 92; 
      
/* Parameters for BusTools_TimeTagMode() function: */
      public const UInt16 API_TT_MICRO    = 0x0;         /* Microsecond timetag default  */
      public const UInt16 API_TT_NANO     = 0x10;        /* Nanosecond resolution        */
      public const Int16 API_TT_DEFAULT   = -1;
      public const UInt16 API_TTD_RELM    = 0;
      public const UInt16 API_TTD_IRIG    = 1;
      public const UInt16 API_TTD_DATE    = 2;
      public const UInt16 API_TTD_REL0    = 3;
      public const UInt16 API_TTI_ZERO    = 0;
      public const UInt16 API_TTI_DAY     = 1;
      public const UInt16 API_TTI_IRIG    = 2;
      public const UInt16 API_TTI_EXT     = 3;
      public const UInt16 API_TTI_IRIG64  = 4;         /* TTInit TT = time since midnight (Host clock) 64BIT TT  */
      public const UInt16 API_TTI_DAY64   = 5;         /* TTInit TT = time since midnight (Host clock)           */
      public const UInt16 API_TTM_FREE    = 0;
      public const UInt16 API_TTM_RESET   = 1;
      public const UInt16 API_TTM_SYNC    = 2;
      public const UInt16 API_TTM_RELOD   = 3;
      public const UInt16 API_TTM_IRIG    = 4;          /* TTMode TT is reset to the external or internal IRIG value */
      public const UInt16 API_TTM_AUTO    = 5;          /* TTMode TT is automatically incremented on external pulse  */
      public const UInt16 API_TTM_XCLK    = 6;  

      public const UInt16 BTD_OK                = 0;
      public const UInt16 BTD_ERR_PARAM         = 1;
      public const UInt16 BTD_ERR_NOACCESS      = 2;
      public const UInt16 BTD_ERR_INUSE         = 3;
      public const UInt16 BTD_ERR_BADADDR       = 4;
      public const UInt16 BTD_ERR_NODETECT      = 5;
      public const UInt16 BTD_ERR_BADCFG        = 6;
      public const UInt16 BTD_ERR_NOTSETUP      = 7;
      public const UInt16 BTD_ERR_READFAIL      = 8;
      public const UInt16 BTD_ERR_FPGALOAD      = 8;
      public const UInt16 BTD_ERR_WRITEFAIL     = 9;
      public const UInt16 BTD_ERR_NOMEMORY      = 10;
      public const UInt16 BTD_ERR_BADDETECT     = 11;
      public const UInt16 BTD_BAD_DEVICE_ID     = 11;
      public const UInt16 BTD_ERR_BADADDRMAP    = 12;
      public const UInt16 BTD_ERR_BADEXTMEM     = 13;
      public const UInt16 BTD_ERR_BADBOARDTYPE  = 14;
      public const UInt16 BTD_ERR_BADWCS        = 15;
      public const UInt16 BTD_NO_PCI_SERVICES   = 16;
      public const UInt16 BTD_NO_PCI_CARRIER    = 17;
      public const UInt16 BTD_NO_PLATFORM       = 18;
      public const UInt16 BTD_BAD_MANUFACTURER  = 19;
      public const UInt16 BTD_BAD_MODEL         = 20;
      public const UInt16 BTD_BAD_SERIAL_PROM   = 21;
      public const UInt16 BTD_NEW_SERIAL_PROM   = 22;
      public const UInt16 BTD_CHAN_NOT_PRESENT  = 23;
      public const UInt16 BTD_NO_SUPPORT        = 24;
      public const UInt16 BTD_NON_SUPPORT       = 24;
      public const UInt16 BTD_BAD_HW_INTERRUPT  = 25;
      public const UInt16 BTD_FPGA_NOT_CLEAR    = 26;
      public const UInt16 BTD_NEW_PCCARD_FW     = 27;    /* PCC-1553 firmware is too new for this version of the API */
      public const UInt16 BTD_OLD_PCCARD_FW     = 28;    /* PCC-1553 firmware is too old, use the JAM Player to update it */
      public const UInt16 BTD_BAD_CONF_FILE     = 29;
      
      public const UInt16 BTD_NO_DRV_MOD        = 30;    /* CEI-ERROR -- No Driver Module found */
      public const UInt16 BTD_IOCTL_DEV_ERR     = 31;    /* CEI-ERROR -- Error in ioctl get device */
      public const UInt16 BTD_IOCTL_SET_REG     = 32;    /* CEI-ERROR -- Error in ioctl set region */
      public const UInt16 BTD_IOCTL_REG_SIZE    = 33;    /* CEI-ERROR -- Error in getting ioclt region size */
      public const UInt16 BTD_IOCTL_GET_REG     = 34;    /* CEI-ERROR -- Error in ioctl get region */
      public const UInt16 BTD_BAD_SIZE          = 35;    /* CEI-ERROR -- Region size is 0 */
      public const UInt16 BTD_BAD_PROC_ID       = 36;    /* CEI-INFO -- Unable to set process ID */
      public const UInt16 BTD_HASH_ERR          = 37;    /* CEI-INFO -- Unable to setup hash table */
      public const UInt16 BTD_NO_HASH_ENTRY     = 38;    /* CEI-INFO -- No hash table entry found */
      public const UInt16 BTD_WRONG_BOARD       = 39;    /* CEI-INFO -- Wrong board type for command */
      public const UInt16 BTD_MODE_MISMATCH     = 40;    /* CEI-INFO -- IPD1553 mismatch in the mode */
      public const UInt16 BTD_IRIG_NO_LOW_PEAK  = 41;
      public const UInt16 BTD_IRIG_NO_HIGH_PEAK = 42;
      public const UInt16 BTD_IRIG_LEVEL_ERR    = 43;
      public const UInt16 BTD_IRIG_NO_SIGNAL    = 44;
      public const UInt16 BTD_RTADDR_PARITY     = 45;    /* CEI-ERROR -- Parity Error on Hardwired RT address lines */
      public const UInt16 BTD_BAD_BYTE_COUNT    = 47;    /* CEI-ERROR -- Byte count not on 4 byte boundary */
      public const UInt16 BTD_TIMER_FAIL        = 48;    /* CEI-ERROR -- failed to create a timer */
      
      public const UInt16 BTD_ERR_NOWINRT       = 50;
      public const UInt16 BTD_ERR_BADREGISTER   = 51;
      public const UInt16 BTD_ERR_BADOPEN       = 52;
      public const UInt16 BTD_UNKNOWN_BUS       = 53;
      public const UInt16 BTD_BAD_LL_VERSION    = 54;
      public const UInt16 BTD_BAD_INT_EVENT     = 55;
      public const UInt16 BTD_ISR_SETUP_ERROR   = 56;
      public const UInt16 BTD_CREATE_ISR_THREAD = 57;
      public const UInt16 BTD_NO_REGIONS_TO_MAP = 58;    /* CEI-ERROR -- No regions requested in call to vbtMapBoardAddresses */
      public const UInt16 BTD_RESOURCE_ERR      = 60;    /* CEI-ERROR -- Integrity Resource Error */
      public const UInt16 BTD_READ_IODEV_ERR    = 61;    /* CEI-ERROR -- Integrity IO Device Read Error */
      public const UInt16 BTD_MEMREG_ERR        = 62;    /* CEI-ERROR -- Integrity error getting memory region */
      public const UInt16 BTD_MEM_MAP_ERR       = 63;    /* CEI-ERROR -- Integrity Memory Mapping error */
      public const UInt16 BTD_CLK_RATE_NOT_SET  = 64;    /* CEI-ERROR -- Error setting clk rate */
      public const UInt16 BTD_LL_CLOSE_ERR      = 65;    /* CEI_ERROR -- Failed to close 1553 device */
      public const UInt16 BTD_LL_OPEN_ERR       = 66;    /* CEI_ERROR -- Failed to open 1553 device */
      public const UInt16 BTD_LL_LINK_ERR       = 67;    /* CEI_ERROR -- Failure linking to installation library (vbtOpen1553Channel) */

      public const UInt16 BTD_VIOPEN_FAIL       = 70;    /* CEI-ERROR -- viOpen Error */
      public const UInt16 BTD_VIMAPADDRESS_FAIL = 71;    /* CEI-ERROR -- viMapAddress Error */
      public const UInt16 BTD_VIOPENDEFAULTRM   = 72;    /* CEI-ERROR -- viOpenDefaultRM Error */
      public const UInt16 BTD_VIUNMAP_ERR       = 73;    /* CEI-ERROR -- viUnMapAddress Error */

      public const UInt16 BTD_SEM_CREATE        = 80;    /* Error Creating semaphore */
      public const UInt16 BTD_TASK_CREATE       = 81;    /* Error spawning task */
      public const Int16 BTD_EVENT_WAIT_FAILED  = -82;   /* CEI-ERROR -- Event Wait Failure */
      public const Int16 BTD_EVENT_WAIT_ABANDONED = -83;   /* CEI-ERROR -- Event Wait Abandoned */
      public const UInt16 BTD_EVENT_WAIT_TIMEOUT = 84;   /* CEI-INFO -- Timeout on Event Wait */
      public const Int16 BTD_EVENT_WAIT_UNKNOWN = -85;  /* CEI-ERROR -- Unknown Event Error */
      public const UInt16 BTD_EVENT_SIGNAL_ERR  = 86;    /* CEI-ERROR -- Error Occurred During Event Signal */
      public const UInt16 BTD_SET_PRIORITY_ERR  = 87;    /* CEI-ERROR -- Error Setting Thread Priority */
      public const UInt16 BTD_THRD_CREATE_FAIL  = 88;    /* CEI-ERROR -- Thread Create Failure */

      public const UInt16 BTD_CLOSE_ERR         = 90;    /* CEI-ERROR -- Failed to close 1553 device */
      public const UInt16 BTD_OPEN_ERR          = 91;    /* CEI-ERROR -- Failed to open 1553 device */
      public const UInt16 BTD_VBT_OPEN_ERR      = 92;    /* CEI-ERROR -- Failure in vbtOpen1553Channel */
      public const UInt16 BTD_FIND_DEV_ERR      = 93;    /* CEI_ERROR -- Failure in BusTools_FindDevice */
      public const UInt16 BTD_LIST_DEV_ERR      = 94;    /* CEI_ERROR -- Failure in BusTools_ListDevices */

      public const UInt16 BTD_ERR_SEM_OBJ       = 97;   /* CEI-ERROR -- Failed to open/close/destroy a semaphore */
      public const UInt16 BTD_ERR_SEM_OPER      = 98;   /* CEI-ERROR -- Failed to lock/unlock a semaphore */
      public const UInt16 BTD_ERR_EVENT_OBJ     = 99;   /* CEI-ERROR -- Failed to create/destroy an event object */
      public const UInt16 BTD_ERR_SHMEM_OBJ     = 100;   /* failed to create/destroy shared memory mapping object */
      public const UInt16 BTD_ERR_SHMEM_MAP     = 101;   /* failed to map/unmap shared memory block */
      public const UInt16 BTD_ERR_SHMEM_ATTR    = 102;   /* failed to obtain shared memory block attributes */
      public const UInt16 BTD_ERR_MUTEX_OBJ     = 103;   /* failed to create/destroy mutex object */
      public const UInt16 BTD_ERR_MUTEX_ATTR    = 104;   /* failed to update mutex attributes */
      public const UInt16 BTD_ERR_MUTEX_LOCK    = 105;   /* failed to acquire/release mutex */
      public const UInt16 BTD_ERR_COND_OBJ      = 106;   /* failed to create/destroy condition variable object */
      public const UInt16 BTD_ERR_COND_ATTR     = 107;   /* failed to update condition variable attributes */
      public const UInt16 BTD_ERR_COND_OPER     = 108;   /* failed to wait/signal condition variable */
      public const UInt16 BTD_ERR_IPC_KEY       = 109;   /* failed to obtain unique IPC key */
      public const UInt16 BTD_ERR_CFGLOCK_OBJ   = 110;   /* failed to create/destroy config lock object */
      public const UInt16 BTD_ERR_CFGLOCK_ATTR  = 111;   /* failed to get/set config lock attributes */
      public const UInt16 BTD_ERR_CFGLOCK_LOCK  = 112;   /* failed to acquire/release config lock */
      public const UInt16 BTD_ERR_READ_PCI_CFG  = 113;   /* failed to read PCI configuration register */
      public const UInt16 BTD_ERR_LOAD_CEIINST  = 114;   /* failed to load cei_install library */

      public const UInt16 BTD_ERR_USB_PROT      = 115;   /* CEI-ERROR -- Failure in the USB protocol */
      public const UInt16 BTD_ERR_USB_OPER      = 116;   /* CEI-ERROR -- Failure in the USB operation */
      public const UInt16 BTD_ERR_FIFO_OPER     = 117;   /* CEI-ERROR -- Failure in the FIFO operation */

      public const UInt16 API_SUCCESS = 0;
      public const UInt16 API_FEATURE_SUPPORT      = 120;   // CEI-INFO -- Feature supported by board
      public const UInt16 API_CONTINUE             = 121;   // CEI-INFO -- API function should continue execution normally
      public const UInt16 API_RETURN_SUCCESS       = 122;   // CEI-INFO -- API function should return immediately with API_SUCCESS
      public const UInt16 API_NEVER_CALL_AGAIN     = 123;   // CEI-INFO -- User function is never to be called again
      public const UInt16 API_INIT_NO_SUPPORT      = 124;   // CEI-WARN -- Cannot initialize board type with this function
      public const UInt16 API_NO_CHANNEL_MAP       = 125;   // CEI_WARN -- Channel mapping not support for current card type
      public const UInt16 API_OVER_TEMP_ALARM      = 130;   // CEI_INFO -- Board Temperature sensor reporting Over Temp
      public const UInt16 API_BUSTOOLS_INT_USED    = 170;   // CEI-WARN -- Interrupt on card already in use
      public const UInt16 API_NULL_PTR             = 171;   // CEI-WARN -- NULL Pointer passed to function
      public const UInt16 API_MAX_CHANNELS_INUSE   = 180;   // CEI-WARN -- Maximum 1553 channels already in use
      public const UInt16 API_CARDNUM_INUSE        = 181;   // CEI-WARN -- cardnum in already in use
      public const UInt16 API_BAD_PRODUCT_LIST     = 182;   // CEI-WARN -- Unable to build the Condor Engineering Product list
      public const UInt16 API_BAD_DEVICE_ID        = 183;   // CEI-WARN -- Bad device ID
      public const UInt16 API_INSTALL_INIT_FAIL    = 184;   // CEI-ERROR -- CEI_INSTALL init failure
      public const UInt16 API_NO_POLLING           = 190;   // CEI-WARN -- Polling is not enabled
      public const UInt16 API_TIMER_ERR            = 191;   // CEI-ERROR -- Error setting up polling timer
      public const UInt16 API_DAC_ERROR            = 192;   // CEI-ERROR -- DAC Operation Error
      public const UInt16 API_TIMEOUT_ERR          = 193;   // CEI-ERROR -- Timeout occurred during timed delay.
      public const UInt16 API_PARAM_CONFLICT       = 194;   // CEI-INFO -- Conflicting parameters passed to function.
      public const UInt16 API_NO_INTERRUPT_SUPPORT = 195;   // CEI-ERROR -- Interrupts are not support for the board type
      
      
      public const UInt16 API_BUSTOOLS_INITED      = 201;
      public const UInt16 API_BUSTOOLS_NOTINITED   = 202;
      public const UInt16 API_BUSTOOLS_BADCARDNUM  = 203;
      public const UInt16 API_BUSTOOLS_BADINTTYPE  = 204;
      public const UInt16 API_BUSTOOLS_BADBUFSIZE  = 205;
      public const UInt16 API_BUSTOOLS_BADCOUPLING = 206;
      public const UInt16 API_BUSTOOLS_BADVOLTAGE  = 207;
      public const UInt16 API_BUSTOOLS_BADSEGNUM   = 208;
      public const UInt16 API_BUSTOOLS_EVENBCOUNT  = 209;
      public const UInt16 API_BUSTOOLS_BADMEMORY   = 210;
      public const UInt16 API_BUSTOOLS_TOO_MANY    = 211;
      public const UInt16 API_BUSTOOLS_FIFO_BAD    = 212;
      public const UInt16 API_BUSTOOLS_NO_OBJECT   = 213;
      public const UInt16 API_BUSTOOLS_BAD_REGS    = 214;
      public const UInt16 API_BUSTOOLS_EVENADDR    = 214;      
      public const UInt16 API_BUSTOOLS_NO_FILE     = 215;
      public const UInt16 API_BUSTOOLS_NO_MEMORY   = 216;
      public const UInt16 API_HW_IQPTR_ERROR       = 217;
      public const UInt16 API_BIT_BC_RT_FAIL_PRI   = 218;   /* CEI-ERROR -- BIT failure/data error detected on BC-RT primary bus */
      public const UInt16 API_BIT_BC_RT_FAIL_SEC   = 219;   /* CEI-ERROR -- BIT failure/data error detected on BC-RT secondary bus */
      public const UInt16 API_BUSTOOLS_FIFO_DUP    = 220;   /* CEI-ERROR -- Specified API_INT_FIFO structure is already in use.V4.35.ajh */
      public const UInt16 API_BIT_BM_RT_FAIL_PRI   = 221;   /* CEI-ERROR -- BIT failure/data error detected on BM-RT primary bus */
      public const UInt16 API_BIT_BM_RT_FAIL_SEC   = 222;   /* CEI-ERROR -- BIT failure/data error detected on BM-RT secondary bus */
      public const UInt16 API_STRUCT_ALIGN         = 223;   /* CEI-ERROR -- Structure Alignment Incorrect. */
      public const UInt16 API_BUSTOOLS_DWORD_SIZE  = 224;   /* CEI-WARN -- DWORD byte count must be mulitple of 4. */
      public const UInt16 API_HARDWARE_NOSUPPORT   = 225;
      public const UInt16 API_OUTDATED_FIRMWARE    = 226;
      public const UInt16 API_NO_OS_SUPPORT        = 227;
      public const UInt16 API_NO_BUILD_SUPPORT     = 228;      
      public const UInt16 API_CHANNEL_OPEN_OTHER   = 229;   /* CEI-WARN -- Board or channel already opened as another cardnum */
      public const UInt16 API_SINGLE_FUNCTION_ERR  = 231;   /* CEI-WARN -- You have attempted to start multiple functions on a single function board */
      public const UInt16 API_CANT_LOAD_USER_DLL   = 232;   /* CEI-WARN -- Cannot load specified user DLL */
      public const UInt16 API_REGISTERFUNCTION_OFF = 233;   /* CEI-WARN -- RegisterFunction operations not enabled */
      public const UInt16 API_DUAL_FUNCTION_ERR    = 234;   /* CEI-WARN -- You have attempted to start RT and BC functions on a dual function board */
      public const UInt16 API_SINGLE_RT_MODE_ERR   = 235;   /* CEI_WARN -- Attempting to start the Bus Controller while in single RT mode */
      public const UInt16 API_BAD_PARAM	         = 240;   /* CEI-WARN -- Bad paramenter for the function call */
      public const UInt16 API_EI_BADMSGTYPE        = 252;
      public const UInt16 API_EI_ILLERRORNO        = 253;
      public const UInt16 API_EI_ILLERRORADDR      = 254;
      public const UInt16 API_BAD_ADDR_TYPE        = 271;
      public const UInt16 API_BAD_DISCRETE         = 280;   /* CEI-WARN -- Attempting to confirgure invalid discrete */
      public const UInt16 API_OUTPUT_DISCRETE      = 281;   /* CEI-WARN -- Attempting to read from an output */
      public const UInt16 API_INPUT_DISCRETE       = 282;   /* CEI-WARN -- Attempting to write to an input */
      public const UInt16 API_MEM_ALLOC_ERR        = 283;   /* CEI-ERROR -- Error allocating memory */
      public const UInt16 API_BADDATATYPE	         = 284;   /* CEI-WARN -- Bad data type for EU conversion.  */
      public const UInt16 API_BADBCDDATA           = 285;   /* CEI-WARN -- Bad data for BCD EU conversion. */
      public const UInt16 API_BADTRANSLATE         = 286;   /* CEI-WARN -- Bad translation table data, for translate EU conversion. */
      public const UInt16 API_BADFACTORTYPE        = 287;   /* CEI-WARN -- Bad factor type for scaled EU conversion. */
      public const UInt16 API_CHANNEL_SHARED       = 290;   /* CEI_WARN -- Channel Already shared */
      public const UInt16 API_CHANNEL_NOTSHARED    = 291;   /* CEI_WARN -- Channel not shared */
      public const UInt16 API_SINGLE_FUNCTION      = 295;   /* CEI-INFO -- Board is single-function */
      public const UInt16 API_DUAL_FUNCTION        = 296;   /* CEI-INFO -- Board is dual-function */
      public const UInt16 API_MULTI_FUNCTION       = 297;   /* CEI-INFO -- Board is multi-function */
      public const UInt16 API_SINGLE_RT            = 298;   /* CEI_INFO -- board is in single RT mode */
      public const UInt16 API_TEMP_SENSOR_ERR      = 299;   /* CEI_INFO -- Temperature Sensor Error wrong manufacturer ID */

      public const UInt16 API_BC_NOTINITED         = 301;
      public const UInt16 API_BC_INITED            = 302;
      public const UInt16 API_BC_RUNNING           = 303;
      public const UInt16 API_BC_NOTRUNNING        = 304;
      public const UInt16 API_BC_MEMORY_OFLOW      = 305;
      public const UInt16 API_BC_ILLEGAL_MBLOCK    = 306;
      public const UInt16 API_BC_MBLOCK_NOMATCH    = 307;
      public const UInt16 API_BC_MBUF_NOT_ALLOC    = 308;
      public const UInt16 API_BC_MBUF_ALLOCD       = 309;
      public const UInt16 API_BC_ILLEGAL_NEXT      = 310;
      public const UInt16 API_BC_ILLEGAL_PREV      = 311;
      public const UInt16 API_BC_ILLEGAL_BRANCH    = 312;
      public const UInt16 API_BC_MESS1_COND        = 313;
      public const UInt16 API_BC_BAD_COND_ADDR     = 314;
      public const UInt16 API_BC_BADTIMEOUT1       = 315;
      public const UInt16 API_BC_BADTIMEOUT2       = 316;
      public const UInt16 API_BC_BADFREQUENCY      = 317;
      public const UInt16 API_BC_HALTERROR         = 318;
      public const UInt16 API_BC_MCODE3_BUFFER     = 319;
      public const UInt16 API_BC_MCODE3_BUS        = 320;
      public const UInt16 API_BC_ILLEGAL_DBLOCK    = 320;
      public const UInt16 API_BC_MCODE4_PINGPONG   = 321;
      public const UInt16 API_BC_MCODE4_USEBUFFA   = 322;
      public const UInt16 API_BC_BOTHBUFFERS       = 323;
      public const UInt16 API_BC_BOTHBUSES         = 324;
      public const UInt16 API_BC_MCODE4_UPDATE     = 325;
      public const UInt16 API_BC_UPDATEMESSTYPE    = 326;
      public const UInt16 API_BC_ILLEGALMESSAGE    = 327;
      public const UInt16 API_BC_ILLEGALTARGET     = 328;
      public const UInt16 API_BC_NOTMESSAGE        = 329;
      public const UInt16 API_BC_NOTNOOP           = 330;
      public const UInt16 API_BC_APERIODIC_RUNNING = 331;   /* CEI-WARN -- BC Aperiodics still running, cannot start new msg list */
      public const UInt16 API_BC_APERIODIC_TIMEOUT = 332;   /* CEI-ERROR -- BC Aperiodic messages did not complete in time */
      public const UInt16 API_BC_CANT_NOOP         = 333;   /* CEI-WARN -- BC cannot noop or un-noop a noop message */
      public const UInt16 API_BC_READ_TIMEOUT      = 335;   /* CEI-INFO -- RT timeout when attempting to read data. */
      public const UInt16 API_BC_READ_NODATA       = 336;   /* CEI-INFO -- No RT data in int queue */
      public const UInt16 API_BC_AUTOINC_INUSE     = 337;   /* CEI-WARN -- Auto-Increment in use for message */
      public const UInt16 API_BC_IS_RUNNING        = 338;   /* CEI-INFO -- BC is running */
      public const UInt16 API_BC_IS_STOPPED        = 339;   /* CEI-INFO -- BC is stopped */
      public const UInt16 API_BC_MULTI_BUFFER_ERR  = 340;   /* CEI_WARN -- Using wrong function to setup Bus Controller.  Use BusTools_BC_BufferAlloc()" */
      public const UInt16 API_BC_BAD_DATA_BUFFER   = 341;   /* CEI_WARN -- Data buffer not allocated */
      
      public const UInt16 API_BM_NOTINITED         = 401;
      public const UInt16 API_BM_INITED            = 402;
      public const UInt16 API_BM_RUNNING           = 403;
      public const UInt16 API_BM_NOTRUNNING        = 404;
      public const UInt16 API_BM_MEMORY_OFLOW      = 405;
      public const UInt16 API_BM_CBUF_EXISTS       = 406;
      public const UInt16 API_BM_CBUF_NOTDEFINED   = 407;
      public const UInt16 API_BM_ILLEGAL_ADDR      = 408;
      public const UInt16 API_BM_ILLEGAL_SUBADDR   = 409;
      public const UInt16 API_BM_ILLEGAL_TRANREC   = 410;
      public const UInt16 API_BM_ILLEGAL_MBUFID    = 411;
      public const UInt16 API_BM_MBUF_NOMATCH      = 412;
      public const UInt16 API_BM_WRAP_AROUND       = 413;
      public const UInt16 API_BM_ILLEGAL_MESSAGE   = 414;
      public const UInt16 API_BM_MSG_ALLOC_CALLED =  415;   /* CEI-WARN -- BM_MessageAlloc has already been called */
      public const UInt16 API_BM_HW_WRAP_AROUND   =  416;   /* CEI-ERROR -- BM HW message buffer has overflowed, data has been lost */
      public const UInt16 API_BM_POINTER_REG_BAD  =  417;   /* CEI-ERROR -- BM HW pointer register contents invalid */
      public const UInt16 API_BM_READ_TIMEOUT     =  418;   /* CEI-INFO -- BM timeout when attempting to read data. */
      public const UInt16 API_BM_READ_NODATA      =  419;   /* CEI-INFO -- No BM data in int queue */
      public const UInt16 API_BM_1760_ERROR       =  420;   /* CEI-INFO -- Checksum error on MIL-STD-1760 message. */
      public const UInt16 API_BM_BAD_HEAD_PTR     =  421;   /* CEI-ERROR -- BM Head pointer not within range. */

      public const UInt16 API_RT_NOTINITED         = 501;
      public const UInt16 API_RT_INITED            = 502;
      public const UInt16 API_RT_RUNNING           = 503;
      public const UInt16 API_RT_NOTRUNNING        = 504;
      public const UInt16 API_RT_MEMORY_OFLOW      = 505;
      public const UInt16 API_RT_CBUF_EXISTS       = 506;
      public const UInt16 API_RT_CBUF_NOTDEFINED   = 507;
      public const UInt16 API_RT_ILLEGAL_ADDR      = 508;
      public const UInt16 API_RT_ILLEGAL_SUBADDR   = 509;
      public const UInt16 API_RT_ILLEGAL_TRANREC   = 510;
      public const UInt16 API_RT_ILLEGAL_MBUFID    = 511;
      public const UInt16 API_RT_TOOMANY_MBUFS     = 512;
      public const UInt16 API_RT_CBUF_BROAD        = 513;
      public const UInt16 API_RT_CBUF_NOTBROAD     = 514;
      public const UInt16 API_RT_MBUF_NOMATCH      = 515;
      public const UInt16 API_RT_BROADCAST_DISABLE = 516;
      public const UInt16 API_RT_SELF_TEST_MODE    = 517;
      public const UInt16 API_RT_READ_TIMEOUT      = 518;
      public const UInt16 API_RT_READ_NODATA       = 519;
      public const UInt16 API_NO_HARDWIRE_RT       = 520;   /* CEI-INFO -- RT hard-wired address not enabled. */
      public const UInt16 API_RT_AUTOINC_INUSE     = 522;   /* CEI-WARN -- Auto-Increment already in use for message */
      public const UInt16 API_SRT_OVERRIDE         = 530;   /* CEI_INFO -- Only one RT runs in sRT mode.  Current RT is overwritten. */
      public const UInt16 API_BUSTOOLS_NO_SUPPORT  = 531;   /* CEI_INFO -- API function is not support in this version firmware */

      public const UInt16 API_ZEROXNG_SET          = 600;   /* CEI-WARN -- Only one zero crossing error can be injected in to a message */
      public const UInt16 API_LOW_MINOR_OFLOW      = 605;

      public const UInt16 API_LV_BADARRAY          = 700;   /* CEI-ERROR -- LabView array structure not correctly setup */
      public const UInt16 API_NO_LV_SUPPORT        = 701;   /* CEI-ERROR -- Function not supported in LabView */

      public const UInt16 API_PLAYBACK_INIT_ERROR  = 801;
      public const UInt16 API_PLAYBACK_BAD_THREAD  = 802;
      public const UInt16 API_PLAYBACK_BAD_FILE    = 803;
      public const UInt16 API_PLAYBACK_BAD_EVENT   = 804;
      public const UInt16 API_PLAYBACK_BUF_EMPTY   = 805;
      public const UInt16 API_PLAYBACK_BAD_EXIT    = 806;
      public const UInt16 API_PLAYBACK_BAD_MEMORY  = 807;
      public const UInt16 API_PLAYBACK_DISK_READ   = 808;
      public const UInt16 API_PLAYBACK_RUNNING     = 809;
      public const UInt16 API_PLAYBACK_BAD_ALLOC   = 810;
      public const UInt16 API_PLAYBACK_TIME_GAP    = 811;   /* CEI-INFO -- There larger gaps in time tags in playback file. */
      public const UInt16 API_PLAYBACK_TIME_ORDER  = 812;   /* CEI-ERROR -- Time tags in playback file out of sequence. */
      public const UInt16 API_PLAYBACK_FILE_ERR    = 814;   /* CEI-ERROR -- File is not .BMDX file  */

      public const UInt16 API_TIMETAG_BAD_DISPLAY  = 901;   // CEI-WARN -- Unknown or unsupported Time Tag display format
      public const UInt16 API_TIMETAG_BAD_INIT     = 902;   // CEI-WARN -- Unknown Time Tag Initialization method
      public const UInt16 API_TIMETAG_BAD_MODE     = 903;   // CEI-WARN -- Unknown Time Tag Operating Mode
      public const UInt16 API_TIMETAG_NO_DLL       = 904;   // CEI-WARN -- DLL containing BusTools_TimeTagGet() could not be loaded
      public const UInt16 API_TIMETAG_NO_FUNCTION  = 905;   // CEI-WARN -- Could not get the address of the BusTools_TimeTagGet() function
      public const UInt16 API_TIMETAG_USER_ERROR   = 906;   // CEI-WARN -- User function BusTools_TimeTagGet() returned an error
      public const UInt16 API_TIMETAG_WRITE_ERROR  = 907;   // CEI-ERROR -- Cannot write to time tag load register when in API_TM_IRIG mode
      public const UInt16 API_IRIG_NO_SIGNAL       = 908;   // CEI-INFO -- No external IRIG signal present
      public const UInt16 API_TIMETAG_BAD_PERIOD   = 909;   // CEI-WARN -- Time Tag period is not valid

      public const UInt16 API_USB_IF_ERROR         = 1001;  // CEI-CRIT-ERR -- USB Fatal Interface Error
//      public const UInt16 API_INSTALL_ERROR        = 0x80000000;   // CEI-ERROR -- Install Error check
      public const UInt32 API_INSTALL_ERROR = 0x80000000;   // CEI-ERROR -- Install Error check
	  
      /* TTMode TT is generated from external 1 Mhz clock          */
      public const UInt16 TST_SA_WRAP = 1;
      public const UInt16 RT_RCV = 0;
      public const UInt16 RT_XMT = 1;

      public const UInt16 MAX_BT_USR_ALLOC_ENTRY = 256;    /* Maximum recording entries of the user allocated memory */ 
	    
      
// Legacy Definitions  
      public const UInt16 IP1553_ISA   = 0x8;
      public const UInt16 IP1553_PCI   = 0x10;
      public const UInt16 IP1553_VME   = 0x3;
      public const UInt16 IP1553_CP    = 0x4;
      public const UInt16 IP1553_VXI   = 0x5;
      public const UInt16 VIPC616_618  = 0x3;
      public const UInt16 VIPC310      = 0x5;
      public const UInt16 MVME162      = 0x6;
      public const UInt16 ADVME9660    = 0x7;
      public const UInt16 IPD1553_PCI  = 0x120;
      public const UInt16 IPD1553_VME  = 0x140;

      public const UInt16 MCODE_REV_BASIC             = 103;
      public const UInt16 MCODE_REV_BCCHANNELSELECT   = 104;
      public const UInt16 MCODE_REV_NOPINGPONG        = 104;
      public const UInt16 MCODE_REV_ERROR_TRIGGER     = 200;
      public const UInt16 MCODE_REV_HW_ERR_TRIG       = 6;

      public const UInt16 SLOT_A    = 0;
      public const UInt16 SLOT_B    = 1;
      public const UInt16 SLOT_C    = 2;
      public const UInt16 SLOT_D    = 3;
      public const UInt16 SLOT_A_CH1 = 0x0;
      public const UInt16 SLOT_A_CH2 = 0x1;
      public const UInt16 SLOT_B_CH1 = 0x2;
      public const UInt16 SLOT_B_CH2 = 0x3;
      public const UInt16 SLOT_C_CH1 = 0x4;
      public const UInt16 SLOT_C_CH2 = 0x5;
      public const UInt16 SLOT_D_CH1 = 0x6;
      public const UInt16 SLOT_D_CH2 = 0x7;
      public const UInt16 BOARD_MASK = 0xFFF0;

      public const UInt16 ISA_BOARD_MASK = 0xFFF8;
      public const UInt16 SLOT_MASK = 7;
      public const UInt16 MAX_BTA = 16;            /* Use minimum between Win32 and Linux Defs ( Linux = 16) */

      public const UInt16 API_INTTYPE_RT0 = 0;
      public const UInt16 API_INTTYPE_RT1 = 1;
      public const UInt16 API_INTTYPE_RT2 = 2;
      public const UInt16 API_INTTYPE_RT3 = 3;
      public const UInt16 API_INTTYPE_RT4 = 4;
      public const UInt16 API_INTTYPE_RT5 = 5;
      public const UInt16 API_INTTYPE_RT6 = 6;
      public const UInt16 API_INTTYPE_RT7 = 7;
      public const UInt16 API_INTTYPE_RT8 = 8;
      public const UInt16 API_INTTYPE_RT9 = 9;
      public const UInt16 API_INTTYPE_RT10 = 10;
      public const UInt16 API_INTTYPE_RT11 = 11;
      public const UInt16 API_INTTYPE_RT12 = 12;
      public const UInt16 API_INTTYPE_RT13 = 13;
      public const UInt16 API_INTTYPE_RT14 = 14;
      public const UInt16 API_INTTYPE_RT15 = 15;
      public const UInt16 API_INTTYPE_RT16 = 16;
      public const UInt16 API_INTTYPE_RT17 = 17;
      public const UInt16 API_INTTYPE_RT18 = 18;
      public const UInt16 API_INTTYPE_RT19 = 19;
      public const UInt16 API_INTTYPE_RT20 = 20;
      public const UInt16 API_INTTYPE_RT21 = 21;
      public const UInt16 API_INTTYPE_RT22 = 22;
      public const UInt16 API_INTTYPE_RT23 = 23;
      public const UInt16 API_INTTYPE_RT24 = 24;
      public const UInt16 API_INTTYPE_RT25 = 25;
      public const UInt16 API_INTTYPE_RT26 = 26;
      public const UInt16 API_INTTYPE_RT27 = 27;
      public const UInt16 API_INTTYPE_RT28 = 28;
      public const UInt16 API_INTTYPE_RT29 = 29;
      public const UInt16 API_INTTYPE_RT30 = 30;
      public const UInt16 API_INTTYPE_RT31 = 31;
      public const UInt16 API_INTTYPE_BC   = 32;
      public const UInt16 API_INTTYPE_BM   = 33;
      public const UInt16 API_INTTYPE_COUNT = 34;

      public const UInt32 START = 1;
      public const UInt32 STOP  = 0;

      public const Int32 THREAD_PRIORITY_ABOVE_NORMAL  = 1; // from win32
      public const Int32 THREAD_PRIORITY_TIME_CRITICAL = 15; // from win32

      public const UInt32 INFINITE = 0xFFFFFFFF; // from win32
      
      public const UInt32 NOINIT = 0;

// DMA Defines
      public const UInt32 BOARD_TO_HOST = 0;
      public const UInt32 HOST_TO_BOARD = 1;
      

   }
}
