// CDll.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "stdlib.h"


#ifdef _MANAGED
#pragma managed(push, off)
#endif

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
    return TRUE;
}


// this structure mirrors MyStruct in the managed code
typedef struct _EMBEDDED
{
   UINT32 x;
   UINT32 y;
} 
EMBEDDED;


// this structure mirrors MyClass and MySuperStruct in the managed code
typedef struct _MYSTRUCT
{
   UINT (__stdcall *callback)(int x, int y);
   UINT32 number;
   EMBEDDED embedded[3];
   UINT32 anArray[2][3];
} 
MYSTRUCT;


// example of modifying a class that was passd to us.  the .NET program will see the modifications
// because the parameter is marshalled both ways by [In,Out]
int __stdcall Test(MYSTRUCT* pStruct)
{
   // call the managed callback function that was passed as a delegate and save the result.
   int z = pStruct->callback(pStruct->embedded[1].x, pStruct->embedded[1].y);
   pStruct->number = z;

   // modify the embedded array
   pStruct->anArray[0][0] = 10;
   pStruct->anArray[0][1] = 20;
   pStruct->anArray[0][2] = 30;
   pStruct->anArray[1][0] = 40;
   pStruct->anArray[1][1] = 50;
   pStruct->anArray[1][2] = 60;

   return 0;
}

// example of being passed an arrar of structs
int __stdcall ArrayTest1(MYSTRUCT* pArray)
{
   MYSTRUCT a0 = pArray[0];
   MYSTRUCT a1 = pArray[1];
   MYSTRUCT a2 = pArray[2];

   pArray[0].number = 99;

   pArray[0].embedded[0].x = 23;
   pArray[0].embedded[0].y = 24;

   pArray[0].anArray[0][0] = 100;
   pArray[0].anArray[0][1] = 101;
   pArray[0].anArray[0][2] = 102;
   pArray[0].anArray[1][0] = 200;
   pArray[0].anArray[1][1] = 201;
   pArray[0].anArray[1][2] = 202;

   return 0;
}


// example of being passed an arrar of shorts
int __stdcall ArrayTest2(UINT16* pArray)
{
	UINT16 x = pArray[0];
	x = pArray[1];
	x = pArray[2];

	pArray[2] = 100;

	return 0;
}


// example of being passed a pointer to unmanaged memory.  the .NET app saved the pointer, but it can't
// directly access the unmanaged memory.  So, .NET passes back the old pointer which is still valid here, and
// a pointer to a new structure.  If we wanted to, we could copy data from the new structure to our
// unmanaged structure.
int __stdcall UpdateStructure(LPVOID pOldVoid, LPVOID pNewVoid)
{
   MYSTRUCT* pStructOld = (MYSTRUCT*)pOldVoid;
   MYSTRUCT* pStructNew = (MYSTRUCT*)pNewVoid;
   
   return 0;
}


// example where we are passed a **, and make the passed pointer parameter point to an array we allocate in ummanaged code
int __stdcall ReturnArray(UINT8** pArray)
{
   // size must be <= than the managed byte array where the data will be copied to.
   int size = 32;

   UINT8* pBytes = (UINT8*)malloc(size);
   int i;
   for (i = 0; i < size; i++)
   {
      pBytes[i] = (UINT8)i;
   }
   (*pArray) = pBytes;

   return 0;
}

int __stdcall PassByReference(UINT32* pInt)
{
   *pInt = 23;
   return 0;
}


// 2 ways to define an argument as a function pointer.  comment/uncomment the line below to switch.
#define THIS_WAY

#ifdef THIS_WAY
   // create a struture in unmanaged memory, assign the callback member to the parameter that was passed.
   MYSTRUCT* __stdcall CreateStruct( UINT (__stdcall *callback)(int x, int y) )
   {
      MYSTRUCT* pStruct = (MYSTRUCT*)malloc(sizeof(MYSTRUCT));
      pStruct->number = 2324;
      pStruct->callback =  callback;

      // call the callback function that was passed to us
      int z = pStruct->callback(2, 3);

      for (int i = 0; i <= 2; i++)
      {
         pStruct->embedded[i].x = i;
         pStruct->embedded[i].y = i + 1;
      }

      int val = 0;
      for (int x = 0; x < 2; x++)
      {
         for (int y = 0; y < 3; y++)
         {
            pStruct->anArray[x][y] = val++;
         }
      }

      return pStruct;
   }
#else
   // create a atruture in unmanaged memory, assign the callback member to the parameter that was passed.
   MYSTRUCT* __stdcall CreateStruct( LPVOID callback )
   {
      MYSTRUCT* pStruct = (MYSTRUCT*)malloc(sizeof(MYSTRUCT));
      pStruct->number = 2324;
      pStruct->callback =  (UINT (__stdcall *)(int x, int y)) callback;

      // call the callback function that was passed to us
      int z = pStruct->callback(2, 3);

      return pStruct;
   }
#endif

#ifdef _MANAGED
#pragma managed(pop)
#endif

